
@echo off
 @ REM ######################################
 @ REM # Variable to ignore <CR> in DOS
 @ REM # line endings
 @ set SHELLOPTS=igncr

@ REM ######################################
 @ REM # Variable to ignore mixed paths
 @ REM # i.e. G:/$SOPC_KIT_NIOS2/bin
 @ set CYGWIN=nodosfilewarning

@set QUARTUS_BIN=%QUARTUS_ROOTDIR%\\bin
 @if exist %QUARTUS_BIN%\\quartus_pgm.exe (goto DownLoad)

@set QUARTUS_BIN=%QUARTUS_ROOTDIR%\\bin64
 @if exist %QUARTUS_BIN%\\quartus_pgm.exe (goto DownLoad)

:: Prepare for future use (if exes are in bin32)
 @set QUARTUS_BIN=%QUARTUS_ROOTDIR%\\bin32

:DownLoad

set project.sof=DE0_NANO_SMART_CAR.sof
set project.jic=DE0_NANO_SMART_CAR.jic
set device_sfl.sof=sfl_enhanced_ep4ce22.sof

echo ===========================================================
echo "Convert .sof to .jic" 
echo ===========================================================
 %QUARTUS_BIN%\\quartus_cpf -c -d EPCS64 -s EP4CE22 %project.sof% %project.jic%

echo ===========================================================
echo "Programming EPCQ with .jic" 
echo ===========================================================
 %QUARTUS_BIN%\\quartus_pgm.exe -m jtag -c 1 -o "p;%device_sfl.sof%" 
 %QUARTUS_BIN%\\quartus_pgm.exe -m jtag -c 1 -o "p;%project.jic%" 

pause
rm %project.jic%