// nios_system.v

// Generated using ACDS version 15.1 193

`timescale 1 ps / 1 ps
module nios_system (
		output wire       adc_ltc2308_conduit_end_convst,               //               adc_ltc2308_conduit_end.convst
		output wire       adc_ltc2308_conduit_end_sck,                  //                                      .sck
		output wire       adc_ltc2308_conduit_end_sdi,                  //                                      .sdi
		input  wire       adc_ltc2308_conduit_end_sdo,                  //                                      .sdo
		output wire       buzzer_external_connection_export,            //            buzzer_external_connection.export
		input  wire       clk_clk,                                      //                                   clk.clk
		output wire       dc_motor_left_conduit_end_motor_p,            //             dc_motor_left_conduit_end.motor_p
		output wire       dc_motor_left_conduit_end_motor_n,            //                                      .motor_n
		output wire       dc_motor_right_conduit_end_motor_p,           //            dc_motor_right_conduit_end.motor_p
		output wire       dc_motor_right_conduit_end_motor_n,           //                                      .motor_n
		output wire       ir_led_on_external_connection_export,         //         ir_led_on_external_connection.export
		input  wire       ir_rx_conduit_end_export,                     //                     ir_rx_conduit_end.export
		input  wire [1:0] key_external_connection_export,               //               key_external_connection.export
		output wire [7:0] led_external_connection_export,               //               led_external_connection.export
		output wire       light_left_external_connection_export,        //        light_left_external_connection.export
		output wire       light_right_external_connection_export,       //       light_right_external_connection.export
		input  wire       reset_reset_n,                                //                                 reset.reset_n
		output wire       scd_3v3_poweron_n_external_connection_export, // scd_3v3_poweron_n_external_connection.export
		input  wire [3:0] switch_external_connection_export,            //            switch_external_connection.export
		input  wire       tmd_status_external_connection_export,        //        tmd_status_external_connection.export
		input  wire       uart_external_connection_rxd,                 //              uart_external_connection.rxd
		output wire       uart_external_connection_txd,                 //                                      .txd
		input  wire       uart_external_connection_cts_n,               //                                      .cts_n
		output wire       uart_external_connection_rts_n                //                                      .rts_n
	);

	wire         altpll_sys_c0_clk;                                              // altpll_sys:c0 -> [irq_mapper:clk, irq_synchronizer:sender_clk, irq_synchronizer_001:sender_clk, irq_synchronizer_002:sender_clk, jtag_uart:clk, mm_clock_crossing_bridge_io:s0_clk, mm_interconnect_0:altpll_sys_c0_clk, nios2_gen2:clk, onchip_memory:clk, rst_controller_002:clk, rst_controller_003:clk]
	wire         altpll_sys_c1_clk;                                              // altpll_sys:c1 -> [adc_ltc2308:clk, buzzer:clk, dc_motor_left:clk, dc_motor_right:clk, ir_led_on:clk, irq_synchronizer_001:receiver_clk, irq_synchronizer_002:receiver_clk, key:clk, led:clk, light_left:clk, light_right:clk, mm_clock_crossing_bridge_io:m0_clk, mm_interconnect_1:altpll_sys_c1_clk, rst_controller:clk, scd_3v3_poweron_n:clk, switch:clk, sysid_qsys:clock, timer:clk, tmd_status:clk, uart:clk]
	wire  [31:0] nios2_gen2_data_master_readdata;                                // mm_interconnect_0:nios2_gen2_data_master_readdata -> nios2_gen2:d_readdata
	wire         nios2_gen2_data_master_waitrequest;                             // mm_interconnect_0:nios2_gen2_data_master_waitrequest -> nios2_gen2:d_waitrequest
	wire         nios2_gen2_data_master_debugaccess;                             // nios2_gen2:debug_mem_slave_debugaccess_to_roms -> mm_interconnect_0:nios2_gen2_data_master_debugaccess
	wire  [24:0] nios2_gen2_data_master_address;                                 // nios2_gen2:d_address -> mm_interconnect_0:nios2_gen2_data_master_address
	wire   [3:0] nios2_gen2_data_master_byteenable;                              // nios2_gen2:d_byteenable -> mm_interconnect_0:nios2_gen2_data_master_byteenable
	wire         nios2_gen2_data_master_read;                                    // nios2_gen2:d_read -> mm_interconnect_0:nios2_gen2_data_master_read
	wire         nios2_gen2_data_master_readdatavalid;                           // mm_interconnect_0:nios2_gen2_data_master_readdatavalid -> nios2_gen2:d_readdatavalid
	wire         nios2_gen2_data_master_write;                                   // nios2_gen2:d_write -> mm_interconnect_0:nios2_gen2_data_master_write
	wire  [31:0] nios2_gen2_data_master_writedata;                               // nios2_gen2:d_writedata -> mm_interconnect_0:nios2_gen2_data_master_writedata
	wire  [31:0] nios2_gen2_instruction_master_readdata;                         // mm_interconnect_0:nios2_gen2_instruction_master_readdata -> nios2_gen2:i_readdata
	wire         nios2_gen2_instruction_master_waitrequest;                      // mm_interconnect_0:nios2_gen2_instruction_master_waitrequest -> nios2_gen2:i_waitrequest
	wire  [24:0] nios2_gen2_instruction_master_address;                          // nios2_gen2:i_address -> mm_interconnect_0:nios2_gen2_instruction_master_address
	wire         nios2_gen2_instruction_master_read;                             // nios2_gen2:i_read -> mm_interconnect_0:nios2_gen2_instruction_master_read
	wire         nios2_gen2_instruction_master_readdatavalid;                    // mm_interconnect_0:nios2_gen2_instruction_master_readdatavalid -> nios2_gen2:i_readdatavalid
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect;       // mm_interconnect_0:jtag_uart_avalon_jtag_slave_chipselect -> jtag_uart:av_chipselect
	wire  [31:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata;         // jtag_uart:av_readdata -> mm_interconnect_0:jtag_uart_avalon_jtag_slave_readdata
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest;      // jtag_uart:av_waitrequest -> mm_interconnect_0:jtag_uart_avalon_jtag_slave_waitrequest
	wire   [0:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_address;          // mm_interconnect_0:jtag_uart_avalon_jtag_slave_address -> jtag_uart:av_address
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_read;             // mm_interconnect_0:jtag_uart_avalon_jtag_slave_read -> jtag_uart:av_read_n
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_write;            // mm_interconnect_0:jtag_uart_avalon_jtag_slave_write -> jtag_uart:av_write_n
	wire  [31:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata;        // mm_interconnect_0:jtag_uart_avalon_jtag_slave_writedata -> jtag_uart:av_writedata
	wire         mm_interconnect_0_ir_rx_avalon_slave_chipselect;                // mm_interconnect_0:ir_rx_avalon_slave_chipselect -> ir_rx:s_cs_n
	wire  [31:0] mm_interconnect_0_ir_rx_avalon_slave_readdata;                  // ir_rx:s_readdata -> mm_interconnect_0:ir_rx_avalon_slave_readdata
	wire         mm_interconnect_0_ir_rx_avalon_slave_read;                      // mm_interconnect_0:ir_rx_avalon_slave_read -> ir_rx:s_read
	wire         mm_interconnect_0_ir_rx_avalon_slave_write;                     // mm_interconnect_0:ir_rx_avalon_slave_write -> ir_rx:s_write
	wire  [31:0] mm_interconnect_0_ir_rx_avalon_slave_writedata;                 // mm_interconnect_0:ir_rx_avalon_slave_writedata -> ir_rx:s_writedata
	wire  [31:0] mm_interconnect_0_nios2_gen2_debug_mem_slave_readdata;          // nios2_gen2:debug_mem_slave_readdata -> mm_interconnect_0:nios2_gen2_debug_mem_slave_readdata
	wire         mm_interconnect_0_nios2_gen2_debug_mem_slave_waitrequest;       // nios2_gen2:debug_mem_slave_waitrequest -> mm_interconnect_0:nios2_gen2_debug_mem_slave_waitrequest
	wire         mm_interconnect_0_nios2_gen2_debug_mem_slave_debugaccess;       // mm_interconnect_0:nios2_gen2_debug_mem_slave_debugaccess -> nios2_gen2:debug_mem_slave_debugaccess
	wire   [8:0] mm_interconnect_0_nios2_gen2_debug_mem_slave_address;           // mm_interconnect_0:nios2_gen2_debug_mem_slave_address -> nios2_gen2:debug_mem_slave_address
	wire         mm_interconnect_0_nios2_gen2_debug_mem_slave_read;              // mm_interconnect_0:nios2_gen2_debug_mem_slave_read -> nios2_gen2:debug_mem_slave_read
	wire   [3:0] mm_interconnect_0_nios2_gen2_debug_mem_slave_byteenable;        // mm_interconnect_0:nios2_gen2_debug_mem_slave_byteenable -> nios2_gen2:debug_mem_slave_byteenable
	wire         mm_interconnect_0_nios2_gen2_debug_mem_slave_write;             // mm_interconnect_0:nios2_gen2_debug_mem_slave_write -> nios2_gen2:debug_mem_slave_write
	wire  [31:0] mm_interconnect_0_nios2_gen2_debug_mem_slave_writedata;         // mm_interconnect_0:nios2_gen2_debug_mem_slave_writedata -> nios2_gen2:debug_mem_slave_writedata
	wire  [31:0] mm_interconnect_0_altpll_sys_pll_slave_readdata;                // altpll_sys:readdata -> mm_interconnect_0:altpll_sys_pll_slave_readdata
	wire   [1:0] mm_interconnect_0_altpll_sys_pll_slave_address;                 // mm_interconnect_0:altpll_sys_pll_slave_address -> altpll_sys:address
	wire         mm_interconnect_0_altpll_sys_pll_slave_read;                    // mm_interconnect_0:altpll_sys_pll_slave_read -> altpll_sys:read
	wire         mm_interconnect_0_altpll_sys_pll_slave_write;                   // mm_interconnect_0:altpll_sys_pll_slave_write -> altpll_sys:write
	wire  [31:0] mm_interconnect_0_altpll_sys_pll_slave_writedata;               // mm_interconnect_0:altpll_sys_pll_slave_writedata -> altpll_sys:writedata
	wire  [31:0] mm_interconnect_0_mm_clock_crossing_bridge_io_s0_readdata;      // mm_clock_crossing_bridge_io:s0_readdata -> mm_interconnect_0:mm_clock_crossing_bridge_io_s0_readdata
	wire         mm_interconnect_0_mm_clock_crossing_bridge_io_s0_waitrequest;   // mm_clock_crossing_bridge_io:s0_waitrequest -> mm_interconnect_0:mm_clock_crossing_bridge_io_s0_waitrequest
	wire         mm_interconnect_0_mm_clock_crossing_bridge_io_s0_debugaccess;   // mm_interconnect_0:mm_clock_crossing_bridge_io_s0_debugaccess -> mm_clock_crossing_bridge_io:s0_debugaccess
	wire   [9:0] mm_interconnect_0_mm_clock_crossing_bridge_io_s0_address;       // mm_interconnect_0:mm_clock_crossing_bridge_io_s0_address -> mm_clock_crossing_bridge_io:s0_address
	wire         mm_interconnect_0_mm_clock_crossing_bridge_io_s0_read;          // mm_interconnect_0:mm_clock_crossing_bridge_io_s0_read -> mm_clock_crossing_bridge_io:s0_read
	wire   [3:0] mm_interconnect_0_mm_clock_crossing_bridge_io_s0_byteenable;    // mm_interconnect_0:mm_clock_crossing_bridge_io_s0_byteenable -> mm_clock_crossing_bridge_io:s0_byteenable
	wire         mm_interconnect_0_mm_clock_crossing_bridge_io_s0_readdatavalid; // mm_clock_crossing_bridge_io:s0_readdatavalid -> mm_interconnect_0:mm_clock_crossing_bridge_io_s0_readdatavalid
	wire         mm_interconnect_0_mm_clock_crossing_bridge_io_s0_write;         // mm_interconnect_0:mm_clock_crossing_bridge_io_s0_write -> mm_clock_crossing_bridge_io:s0_write
	wire  [31:0] mm_interconnect_0_mm_clock_crossing_bridge_io_s0_writedata;     // mm_interconnect_0:mm_clock_crossing_bridge_io_s0_writedata -> mm_clock_crossing_bridge_io:s0_writedata
	wire   [0:0] mm_interconnect_0_mm_clock_crossing_bridge_io_s0_burstcount;    // mm_interconnect_0:mm_clock_crossing_bridge_io_s0_burstcount -> mm_clock_crossing_bridge_io:s0_burstcount
	wire         mm_interconnect_0_onchip_memory_s1_chipselect;                  // mm_interconnect_0:onchip_memory_s1_chipselect -> onchip_memory:chipselect
	wire  [31:0] mm_interconnect_0_onchip_memory_s1_readdata;                    // onchip_memory:readdata -> mm_interconnect_0:onchip_memory_s1_readdata
	wire  [13:0] mm_interconnect_0_onchip_memory_s1_address;                     // mm_interconnect_0:onchip_memory_s1_address -> onchip_memory:address
	wire   [3:0] mm_interconnect_0_onchip_memory_s1_byteenable;                  // mm_interconnect_0:onchip_memory_s1_byteenable -> onchip_memory:byteenable
	wire         mm_interconnect_0_onchip_memory_s1_write;                       // mm_interconnect_0:onchip_memory_s1_write -> onchip_memory:write
	wire  [31:0] mm_interconnect_0_onchip_memory_s1_writedata;                   // mm_interconnect_0:onchip_memory_s1_writedata -> onchip_memory:writedata
	wire         mm_interconnect_0_onchip_memory_s1_clken;                       // mm_interconnect_0:onchip_memory_s1_clken -> onchip_memory:clken
	wire         mm_clock_crossing_bridge_io_m0_waitrequest;                     // mm_interconnect_1:mm_clock_crossing_bridge_io_m0_waitrequest -> mm_clock_crossing_bridge_io:m0_waitrequest
	wire  [31:0] mm_clock_crossing_bridge_io_m0_readdata;                        // mm_interconnect_1:mm_clock_crossing_bridge_io_m0_readdata -> mm_clock_crossing_bridge_io:m0_readdata
	wire         mm_clock_crossing_bridge_io_m0_debugaccess;                     // mm_clock_crossing_bridge_io:m0_debugaccess -> mm_interconnect_1:mm_clock_crossing_bridge_io_m0_debugaccess
	wire   [9:0] mm_clock_crossing_bridge_io_m0_address;                         // mm_clock_crossing_bridge_io:m0_address -> mm_interconnect_1:mm_clock_crossing_bridge_io_m0_address
	wire         mm_clock_crossing_bridge_io_m0_read;                            // mm_clock_crossing_bridge_io:m0_read -> mm_interconnect_1:mm_clock_crossing_bridge_io_m0_read
	wire   [3:0] mm_clock_crossing_bridge_io_m0_byteenable;                      // mm_clock_crossing_bridge_io:m0_byteenable -> mm_interconnect_1:mm_clock_crossing_bridge_io_m0_byteenable
	wire         mm_clock_crossing_bridge_io_m0_readdatavalid;                   // mm_interconnect_1:mm_clock_crossing_bridge_io_m0_readdatavalid -> mm_clock_crossing_bridge_io:m0_readdatavalid
	wire  [31:0] mm_clock_crossing_bridge_io_m0_writedata;                       // mm_clock_crossing_bridge_io:m0_writedata -> mm_interconnect_1:mm_clock_crossing_bridge_io_m0_writedata
	wire         mm_clock_crossing_bridge_io_m0_write;                           // mm_clock_crossing_bridge_io:m0_write -> mm_interconnect_1:mm_clock_crossing_bridge_io_m0_write
	wire   [0:0] mm_clock_crossing_bridge_io_m0_burstcount;                      // mm_clock_crossing_bridge_io:m0_burstcount -> mm_interconnect_1:mm_clock_crossing_bridge_io_m0_burstcount
	wire         mm_interconnect_1_dc_motor_left_avalon_slave_chipselect;        // mm_interconnect_1:dc_motor_left_avalon_slave_chipselect -> dc_motor_left:s_cs
	wire  [31:0] mm_interconnect_1_dc_motor_left_avalon_slave_readdata;          // dc_motor_left:s_readdata -> mm_interconnect_1:dc_motor_left_avalon_slave_readdata
	wire   [1:0] mm_interconnect_1_dc_motor_left_avalon_slave_address;           // mm_interconnect_1:dc_motor_left_avalon_slave_address -> dc_motor_left:s_address
	wire         mm_interconnect_1_dc_motor_left_avalon_slave_read;              // mm_interconnect_1:dc_motor_left_avalon_slave_read -> dc_motor_left:s_read
	wire         mm_interconnect_1_dc_motor_left_avalon_slave_write;             // mm_interconnect_1:dc_motor_left_avalon_slave_write -> dc_motor_left:s_write
	wire  [31:0] mm_interconnect_1_dc_motor_left_avalon_slave_writedata;         // mm_interconnect_1:dc_motor_left_avalon_slave_writedata -> dc_motor_left:s_writedata
	wire         mm_interconnect_1_dc_motor_right_avalon_slave_chipselect;       // mm_interconnect_1:dc_motor_right_avalon_slave_chipselect -> dc_motor_right:s_cs
	wire  [31:0] mm_interconnect_1_dc_motor_right_avalon_slave_readdata;         // dc_motor_right:s_readdata -> mm_interconnect_1:dc_motor_right_avalon_slave_readdata
	wire   [1:0] mm_interconnect_1_dc_motor_right_avalon_slave_address;          // mm_interconnect_1:dc_motor_right_avalon_slave_address -> dc_motor_right:s_address
	wire         mm_interconnect_1_dc_motor_right_avalon_slave_read;             // mm_interconnect_1:dc_motor_right_avalon_slave_read -> dc_motor_right:s_read
	wire         mm_interconnect_1_dc_motor_right_avalon_slave_write;            // mm_interconnect_1:dc_motor_right_avalon_slave_write -> dc_motor_right:s_write
	wire  [31:0] mm_interconnect_1_dc_motor_right_avalon_slave_writedata;        // mm_interconnect_1:dc_motor_right_avalon_slave_writedata -> dc_motor_right:s_writedata
	wire  [31:0] mm_interconnect_1_sysid_qsys_control_slave_readdata;            // sysid_qsys:readdata -> mm_interconnect_1:sysid_qsys_control_slave_readdata
	wire   [0:0] mm_interconnect_1_sysid_qsys_control_slave_address;             // mm_interconnect_1:sysid_qsys_control_slave_address -> sysid_qsys:address
	wire  [31:0] mm_interconnect_1_tmd_status_s1_readdata;                       // tmd_status:readdata -> mm_interconnect_1:tmd_status_s1_readdata
	wire   [1:0] mm_interconnect_1_tmd_status_s1_address;                        // mm_interconnect_1:tmd_status_s1_address -> tmd_status:address
	wire         mm_interconnect_1_led_s1_chipselect;                            // mm_interconnect_1:led_s1_chipselect -> led:chipselect
	wire  [31:0] mm_interconnect_1_led_s1_readdata;                              // led:readdata -> mm_interconnect_1:led_s1_readdata
	wire   [1:0] mm_interconnect_1_led_s1_address;                               // mm_interconnect_1:led_s1_address -> led:address
	wire         mm_interconnect_1_led_s1_write;                                 // mm_interconnect_1:led_s1_write -> led:write_n
	wire  [31:0] mm_interconnect_1_led_s1_writedata;                             // mm_interconnect_1:led_s1_writedata -> led:writedata
	wire  [31:0] mm_interconnect_1_switch_s1_readdata;                           // switch:readdata -> mm_interconnect_1:switch_s1_readdata
	wire   [1:0] mm_interconnect_1_switch_s1_address;                            // mm_interconnect_1:switch_s1_address -> switch:address
	wire         mm_interconnect_1_light_left_s1_chipselect;                     // mm_interconnect_1:light_left_s1_chipselect -> light_left:chipselect
	wire  [31:0] mm_interconnect_1_light_left_s1_readdata;                       // light_left:readdata -> mm_interconnect_1:light_left_s1_readdata
	wire   [1:0] mm_interconnect_1_light_left_s1_address;                        // mm_interconnect_1:light_left_s1_address -> light_left:address
	wire         mm_interconnect_1_light_left_s1_write;                          // mm_interconnect_1:light_left_s1_write -> light_left:write_n
	wire  [31:0] mm_interconnect_1_light_left_s1_writedata;                      // mm_interconnect_1:light_left_s1_writedata -> light_left:writedata
	wire         mm_interconnect_1_light_right_s1_chipselect;                    // mm_interconnect_1:light_right_s1_chipselect -> light_right:chipselect
	wire  [31:0] mm_interconnect_1_light_right_s1_readdata;                      // light_right:readdata -> mm_interconnect_1:light_right_s1_readdata
	wire   [1:0] mm_interconnect_1_light_right_s1_address;                       // mm_interconnect_1:light_right_s1_address -> light_right:address
	wire         mm_interconnect_1_light_right_s1_write;                         // mm_interconnect_1:light_right_s1_write -> light_right:write_n
	wire  [31:0] mm_interconnect_1_light_right_s1_writedata;                     // mm_interconnect_1:light_right_s1_writedata -> light_right:writedata
	wire         mm_interconnect_1_buzzer_s1_chipselect;                         // mm_interconnect_1:buzzer_s1_chipselect -> buzzer:chipselect
	wire  [31:0] mm_interconnect_1_buzzer_s1_readdata;                           // buzzer:readdata -> mm_interconnect_1:buzzer_s1_readdata
	wire   [1:0] mm_interconnect_1_buzzer_s1_address;                            // mm_interconnect_1:buzzer_s1_address -> buzzer:address
	wire         mm_interconnect_1_buzzer_s1_write;                              // mm_interconnect_1:buzzer_s1_write -> buzzer:write_n
	wire  [31:0] mm_interconnect_1_buzzer_s1_writedata;                          // mm_interconnect_1:buzzer_s1_writedata -> buzzer:writedata
	wire         mm_interconnect_1_timer_s1_chipselect;                          // mm_interconnect_1:timer_s1_chipselect -> timer:chipselect
	wire  [15:0] mm_interconnect_1_timer_s1_readdata;                            // timer:readdata -> mm_interconnect_1:timer_s1_readdata
	wire   [2:0] mm_interconnect_1_timer_s1_address;                             // mm_interconnect_1:timer_s1_address -> timer:address
	wire         mm_interconnect_1_timer_s1_write;                               // mm_interconnect_1:timer_s1_write -> timer:write_n
	wire  [15:0] mm_interconnect_1_timer_s1_writedata;                           // mm_interconnect_1:timer_s1_writedata -> timer:writedata
	wire  [31:0] mm_interconnect_1_key_s1_readdata;                              // key:readdata -> mm_interconnect_1:key_s1_readdata
	wire   [1:0] mm_interconnect_1_key_s1_address;                               // mm_interconnect_1:key_s1_address -> key:address
	wire         mm_interconnect_1_uart_s1_chipselect;                           // mm_interconnect_1:uart_s1_chipselect -> uart:chipselect
	wire  [15:0] mm_interconnect_1_uart_s1_readdata;                             // uart:readdata -> mm_interconnect_1:uart_s1_readdata
	wire   [2:0] mm_interconnect_1_uart_s1_address;                              // mm_interconnect_1:uart_s1_address -> uart:address
	wire         mm_interconnect_1_uart_s1_read;                                 // mm_interconnect_1:uart_s1_read -> uart:read_n
	wire         mm_interconnect_1_uart_s1_begintransfer;                        // mm_interconnect_1:uart_s1_begintransfer -> uart:begintransfer
	wire         mm_interconnect_1_uart_s1_write;                                // mm_interconnect_1:uart_s1_write -> uart:write_n
	wire  [15:0] mm_interconnect_1_uart_s1_writedata;                            // mm_interconnect_1:uart_s1_writedata -> uart:writedata
	wire         mm_interconnect_1_ir_led_on_s1_chipselect;                      // mm_interconnect_1:ir_led_on_s1_chipselect -> ir_led_on:chipselect
	wire  [31:0] mm_interconnect_1_ir_led_on_s1_readdata;                        // ir_led_on:readdata -> mm_interconnect_1:ir_led_on_s1_readdata
	wire   [1:0] mm_interconnect_1_ir_led_on_s1_address;                         // mm_interconnect_1:ir_led_on_s1_address -> ir_led_on:address
	wire         mm_interconnect_1_ir_led_on_s1_write;                           // mm_interconnect_1:ir_led_on_s1_write -> ir_led_on:write_n
	wire  [31:0] mm_interconnect_1_ir_led_on_s1_writedata;                       // mm_interconnect_1:ir_led_on_s1_writedata -> ir_led_on:writedata
	wire         mm_interconnect_1_scd_3v3_poweron_n_s1_chipselect;              // mm_interconnect_1:scd_3v3_poweron_n_s1_chipselect -> scd_3v3_poweron_n:chipselect
	wire  [31:0] mm_interconnect_1_scd_3v3_poweron_n_s1_readdata;                // scd_3v3_poweron_n:readdata -> mm_interconnect_1:scd_3v3_poweron_n_s1_readdata
	wire   [1:0] mm_interconnect_1_scd_3v3_poweron_n_s1_address;                 // mm_interconnect_1:scd_3v3_poweron_n_s1_address -> scd_3v3_poweron_n:address
	wire         mm_interconnect_1_scd_3v3_poweron_n_s1_write;                   // mm_interconnect_1:scd_3v3_poweron_n_s1_write -> scd_3v3_poweron_n:write_n
	wire  [31:0] mm_interconnect_1_scd_3v3_poweron_n_s1_writedata;               // mm_interconnect_1:scd_3v3_poweron_n_s1_writedata -> scd_3v3_poweron_n:writedata
	wire         mm_interconnect_1_adc_ltc2308_slave_chipselect;                 // mm_interconnect_1:adc_ltc2308_slave_chipselect -> adc_ltc2308:slave_chipselect_n
	wire  [31:0] mm_interconnect_1_adc_ltc2308_slave_readdata;                   // adc_ltc2308:slave_readdata -> mm_interconnect_1:adc_ltc2308_slave_readdata
	wire   [3:0] mm_interconnect_1_adc_ltc2308_slave_address;                    // mm_interconnect_1:adc_ltc2308_slave_address -> adc_ltc2308:slave_address
	wire         mm_interconnect_1_adc_ltc2308_slave_read;                       // mm_interconnect_1:adc_ltc2308_slave_read -> adc_ltc2308:slave_read
	wire         mm_interconnect_1_adc_ltc2308_slave_write;                      // mm_interconnect_1:adc_ltc2308_slave_write -> adc_ltc2308:slave_write
	wire  [31:0] mm_interconnect_1_adc_ltc2308_slave_writedata;                  // mm_interconnect_1:adc_ltc2308_slave_writedata -> adc_ltc2308:slave_writedata
	wire         irq_mapper_receiver3_irq;                                       // jtag_uart:av_irq -> irq_mapper:receiver3_irq
	wire  [31:0] nios2_gen2_irq_irq;                                             // irq_mapper:sender_irq -> nios2_gen2:irq
	wire         irq_mapper_receiver0_irq;                                       // irq_synchronizer:sender_irq -> irq_mapper:receiver0_irq
	wire   [0:0] irq_synchronizer_receiver_irq;                                  // ir_rx:irq -> irq_synchronizer:receiver_irq
	wire         irq_mapper_receiver1_irq;                                       // irq_synchronizer_001:sender_irq -> irq_mapper:receiver1_irq
	wire   [0:0] irq_synchronizer_001_receiver_irq;                              // uart:irq -> irq_synchronizer_001:receiver_irq
	wire         irq_mapper_receiver2_irq;                                       // irq_synchronizer_002:sender_irq -> irq_mapper:receiver2_irq
	wire   [0:0] irq_synchronizer_002_receiver_irq;                              // timer:irq -> irq_synchronizer_002:receiver_irq
	wire         rst_controller_reset_out_reset;                                 // rst_controller:reset_out -> [adc_ltc2308:reset_n, buzzer:reset_n, dc_motor_left:reset_n, dc_motor_right:reset_n, ir_led_on:reset_n, irq_synchronizer_001:receiver_reset, irq_synchronizer_002:receiver_reset, key:reset_n, led:reset_n, light_left:reset_n, light_right:reset_n, mm_clock_crossing_bridge_io:m0_reset, mm_interconnect_1:mm_clock_crossing_bridge_io_m0_reset_reset_bridge_in_reset_reset, scd_3v3_poweron_n:reset_n, switch:reset_n, sysid_qsys:reset_n, timer:reset_n, tmd_status:reset_n, uart:reset_n]
	wire         rst_controller_001_reset_out_reset;                             // rst_controller_001:reset_out -> [altpll_sys:reset, ir_rx:reset_n, irq_synchronizer:receiver_reset, mm_interconnect_0:altpll_sys_inclk_interface_reset_reset_bridge_in_reset_reset]
	wire         rst_controller_002_reset_out_reset;                             // rst_controller_002:reset_out -> [jtag_uart:rst_n, mm_clock_crossing_bridge_io:s0_reset, mm_interconnect_0:jtag_uart_reset_reset_bridge_in_reset_reset, onchip_memory:reset, rst_translator:in_reset]
	wire         rst_controller_002_reset_out_reset_req;                         // rst_controller_002:reset_req -> [onchip_memory:reset_req, rst_translator:reset_req_in]
	wire         rst_controller_003_reset_out_reset;                             // rst_controller_003:reset_out -> [irq_mapper:reset, irq_synchronizer:sender_reset, irq_synchronizer_001:sender_reset, irq_synchronizer_002:sender_reset, mm_interconnect_0:nios2_gen2_reset_reset_bridge_in_reset_reset, nios2_gen2:reset_n, rst_translator_001:in_reset]
	wire         rst_controller_003_reset_out_reset_req;                         // rst_controller_003:reset_req -> [nios2_gen2:reset_req, rst_translator_001:reset_req_in]
	wire         nios2_gen2_debug_reset_request_reset;                           // nios2_gen2:debug_reset_request -> rst_controller_003:reset_in0

	TERASIC_LTC2308 #(
		.CLOCK_DUR (50)
	) adc_ltc2308 (
		.clk                (altpll_sys_c1_clk),                               //       clock.clk
		.reset_n            (~rst_controller_reset_out_reset),                 //       reset.reset_n
		.slave_chipselect_n (~mm_interconnect_1_adc_ltc2308_slave_chipselect), //       slave.chipselect_n
		.slave_write        (mm_interconnect_1_adc_ltc2308_slave_write),       //            .write
		.slave_writedata    (mm_interconnect_1_adc_ltc2308_slave_writedata),   //            .writedata
		.slave_read         (mm_interconnect_1_adc_ltc2308_slave_read),        //            .read
		.slave_readdata     (mm_interconnect_1_adc_ltc2308_slave_readdata),    //            .readdata
		.slave_address      (mm_interconnect_1_adc_ltc2308_slave_address),     //            .address
		.ADC_CONVST         (adc_ltc2308_conduit_end_convst),                  // conduit_end.convst
		.ADC_SCK            (adc_ltc2308_conduit_end_sck),                     //            .sck
		.ADC_SDI            (adc_ltc2308_conduit_end_sdi),                     //            .sdi
		.ADC_SDO            (adc_ltc2308_conduit_end_sdo)                      //            .sdo
	);

	nios_system_altpll_sys altpll_sys (
		.clk       (clk_clk),                                          //       inclk_interface.clk
		.reset     (rst_controller_001_reset_out_reset),               // inclk_interface_reset.reset
		.read      (mm_interconnect_0_altpll_sys_pll_slave_read),      //             pll_slave.read
		.write     (mm_interconnect_0_altpll_sys_pll_slave_write),     //                      .write
		.address   (mm_interconnect_0_altpll_sys_pll_slave_address),   //                      .address
		.readdata  (mm_interconnect_0_altpll_sys_pll_slave_readdata),  //                      .readdata
		.writedata (mm_interconnect_0_altpll_sys_pll_slave_writedata), //                      .writedata
		.c0        (altpll_sys_c0_clk),                                //                    c0.clk
		.c1        (altpll_sys_c1_clk),                                //                    c1.clk
		.c2        (),                                                 //                    c2.clk
		.areset    (),                                                 //        areset_conduit.export
		.locked    (),                                                 //        locked_conduit.export
		.phasedone ()                                                  //     phasedone_conduit.export
	);

	nios_system_buzzer buzzer (
		.clk        (altpll_sys_c1_clk),                      //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),        //               reset.reset_n
		.address    (mm_interconnect_1_buzzer_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_1_buzzer_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_1_buzzer_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_1_buzzer_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_1_buzzer_s1_readdata),   //                    .readdata
		.out_port   (buzzer_external_connection_export)       // external_connection.export
	);

	TERASIC_DC_MOTOR_PWM dc_motor_left (
		.clk         (altpll_sys_c1_clk),                                       //        clock.clk
		.reset_n     (~rst_controller_reset_out_reset),                         //        reset.reset_n
		.s_cs        (mm_interconnect_1_dc_motor_left_avalon_slave_chipselect), // avalon_slave.chipselect
		.s_address   (mm_interconnect_1_dc_motor_left_avalon_slave_address),    //             .address
		.s_write     (mm_interconnect_1_dc_motor_left_avalon_slave_write),      //             .write
		.s_writedata (mm_interconnect_1_dc_motor_left_avalon_slave_writedata),  //             .writedata
		.s_read      (mm_interconnect_1_dc_motor_left_avalon_slave_read),       //             .read
		.s_readdata  (mm_interconnect_1_dc_motor_left_avalon_slave_readdata),   //             .readdata
		.DC_MOTOR_P  (dc_motor_left_conduit_end_motor_p),                       //  conduit_end.motor_p
		.DC_MOTOR_N  (dc_motor_left_conduit_end_motor_n)                        //             .motor_n
	);

	TERASIC_DC_MOTOR_PWM dc_motor_right (
		.clk         (altpll_sys_c1_clk),                                        //        clock.clk
		.reset_n     (~rst_controller_reset_out_reset),                          //        reset.reset_n
		.s_cs        (mm_interconnect_1_dc_motor_right_avalon_slave_chipselect), // avalon_slave.chipselect
		.s_address   (mm_interconnect_1_dc_motor_right_avalon_slave_address),    //             .address
		.s_write     (mm_interconnect_1_dc_motor_right_avalon_slave_write),      //             .write
		.s_writedata (mm_interconnect_1_dc_motor_right_avalon_slave_writedata),  //             .writedata
		.s_read      (mm_interconnect_1_dc_motor_right_avalon_slave_read),       //             .read
		.s_readdata  (mm_interconnect_1_dc_motor_right_avalon_slave_readdata),   //             .readdata
		.DC_MOTOR_P  (dc_motor_right_conduit_end_motor_p),                       //  conduit_end.motor_p
		.DC_MOTOR_N  (dc_motor_right_conduit_end_motor_n)                        //             .motor_n
	);

	nios_system_buzzer ir_led_on (
		.clk        (altpll_sys_c1_clk),                         //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),           //               reset.reset_n
		.address    (mm_interconnect_1_ir_led_on_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_1_ir_led_on_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_1_ir_led_on_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_1_ir_led_on_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_1_ir_led_on_s1_readdata),   //                    .readdata
		.out_port   (ir_led_on_external_connection_export)       // external_connection.export
	);

	TERASIC_IRM ir_rx (
		.s_read      (mm_interconnect_0_ir_rx_avalon_slave_read),        //     avalon_slave.read
		.s_cs_n      (~mm_interconnect_0_ir_rx_avalon_slave_chipselect), //                 .chipselect_n
		.s_readdata  (mm_interconnect_0_ir_rx_avalon_slave_readdata),    //                 .readdata
		.s_write     (mm_interconnect_0_ir_rx_avalon_slave_write),       //                 .write
		.s_writedata (mm_interconnect_0_ir_rx_avalon_slave_writedata),   //                 .writedata
		.clk         (clk_clk),                                          //       clock_sink.clk
		.reset_n     (~rst_controller_001_reset_out_reset),              // clock_sink_reset.reset_n
		.ir          (ir_rx_conduit_end_export),                         //      conduit_end.export
		.irq         (irq_synchronizer_receiver_irq)                     // interrupt_sender.irq
	);

	nios_system_jtag_uart jtag_uart (
		.clk            (altpll_sys_c0_clk),                                         //               clk.clk
		.rst_n          (~rst_controller_002_reset_out_reset),                       //             reset.reset_n
		.av_chipselect  (mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect),  // avalon_jtag_slave.chipselect
		.av_address     (mm_interconnect_0_jtag_uart_avalon_jtag_slave_address),     //                  .address
		.av_read_n      (~mm_interconnect_0_jtag_uart_avalon_jtag_slave_read),       //                  .read_n
		.av_readdata    (mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata),    //                  .readdata
		.av_write_n     (~mm_interconnect_0_jtag_uart_avalon_jtag_slave_write),      //                  .write_n
		.av_writedata   (mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata),   //                  .writedata
		.av_waitrequest (mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest), //                  .waitrequest
		.av_irq         (irq_mapper_receiver3_irq)                                   //               irq.irq
	);

	nios_system_key key (
		.clk      (altpll_sys_c1_clk),                 //                 clk.clk
		.reset_n  (~rst_controller_reset_out_reset),   //               reset.reset_n
		.address  (mm_interconnect_1_key_s1_address),  //                  s1.address
		.readdata (mm_interconnect_1_key_s1_readdata), //                    .readdata
		.in_port  (key_external_connection_export)     // external_connection.export
	);

	nios_system_led led (
		.clk        (altpll_sys_c1_clk),                   //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),     //               reset.reset_n
		.address    (mm_interconnect_1_led_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_1_led_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_1_led_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_1_led_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_1_led_s1_readdata),   //                    .readdata
		.out_port   (led_external_connection_export)       // external_connection.export
	);

	nios_system_buzzer light_left (
		.clk        (altpll_sys_c1_clk),                          //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),            //               reset.reset_n
		.address    (mm_interconnect_1_light_left_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_1_light_left_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_1_light_left_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_1_light_left_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_1_light_left_s1_readdata),   //                    .readdata
		.out_port   (light_left_external_connection_export)       // external_connection.export
	);

	nios_system_buzzer light_right (
		.clk        (altpll_sys_c1_clk),                           //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),             //               reset.reset_n
		.address    (mm_interconnect_1_light_right_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_1_light_right_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_1_light_right_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_1_light_right_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_1_light_right_s1_readdata),   //                    .readdata
		.out_port   (light_right_external_connection_export)       // external_connection.export
	);

	altera_avalon_mm_clock_crossing_bridge #(
		.DATA_WIDTH          (32),
		.SYMBOL_WIDTH        (8),
		.HDL_ADDR_WIDTH      (10),
		.BURSTCOUNT_WIDTH    (1),
		.COMMAND_FIFO_DEPTH  (4),
		.RESPONSE_FIFO_DEPTH (4),
		.MASTER_SYNC_DEPTH   (2),
		.SLAVE_SYNC_DEPTH    (2)
	) mm_clock_crossing_bridge_io (
		.m0_clk           (altpll_sys_c1_clk),                                              //   m0_clk.clk
		.m0_reset         (rst_controller_reset_out_reset),                                 // m0_reset.reset
		.s0_clk           (altpll_sys_c0_clk),                                              //   s0_clk.clk
		.s0_reset         (rst_controller_002_reset_out_reset),                             // s0_reset.reset
		.s0_waitrequest   (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_waitrequest),   //       s0.waitrequest
		.s0_readdata      (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_readdata),      //         .readdata
		.s0_readdatavalid (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_readdatavalid), //         .readdatavalid
		.s0_burstcount    (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_burstcount),    //         .burstcount
		.s0_writedata     (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_writedata),     //         .writedata
		.s0_address       (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_address),       //         .address
		.s0_write         (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_write),         //         .write
		.s0_read          (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_read),          //         .read
		.s0_byteenable    (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_byteenable),    //         .byteenable
		.s0_debugaccess   (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_debugaccess),   //         .debugaccess
		.m0_waitrequest   (mm_clock_crossing_bridge_io_m0_waitrequest),                     //       m0.waitrequest
		.m0_readdata      (mm_clock_crossing_bridge_io_m0_readdata),                        //         .readdata
		.m0_readdatavalid (mm_clock_crossing_bridge_io_m0_readdatavalid),                   //         .readdatavalid
		.m0_burstcount    (mm_clock_crossing_bridge_io_m0_burstcount),                      //         .burstcount
		.m0_writedata     (mm_clock_crossing_bridge_io_m0_writedata),                       //         .writedata
		.m0_address       (mm_clock_crossing_bridge_io_m0_address),                         //         .address
		.m0_write         (mm_clock_crossing_bridge_io_m0_write),                           //         .write
		.m0_read          (mm_clock_crossing_bridge_io_m0_read),                            //         .read
		.m0_byteenable    (mm_clock_crossing_bridge_io_m0_byteenable),                      //         .byteenable
		.m0_debugaccess   (mm_clock_crossing_bridge_io_m0_debugaccess)                      //         .debugaccess
	);

	nios_system_nios2_gen2 nios2_gen2 (
		.clk                                 (altpll_sys_c0_clk),                                        //                       clk.clk
		.reset_n                             (~rst_controller_003_reset_out_reset),                      //                     reset.reset_n
		.reset_req                           (rst_controller_003_reset_out_reset_req),                   //                          .reset_req
		.d_address                           (nios2_gen2_data_master_address),                           //               data_master.address
		.d_byteenable                        (nios2_gen2_data_master_byteenable),                        //                          .byteenable
		.d_read                              (nios2_gen2_data_master_read),                              //                          .read
		.d_readdata                          (nios2_gen2_data_master_readdata),                          //                          .readdata
		.d_waitrequest                       (nios2_gen2_data_master_waitrequest),                       //                          .waitrequest
		.d_write                             (nios2_gen2_data_master_write),                             //                          .write
		.d_writedata                         (nios2_gen2_data_master_writedata),                         //                          .writedata
		.d_readdatavalid                     (nios2_gen2_data_master_readdatavalid),                     //                          .readdatavalid
		.debug_mem_slave_debugaccess_to_roms (nios2_gen2_data_master_debugaccess),                       //                          .debugaccess
		.i_address                           (nios2_gen2_instruction_master_address),                    //        instruction_master.address
		.i_read                              (nios2_gen2_instruction_master_read),                       //                          .read
		.i_readdata                          (nios2_gen2_instruction_master_readdata),                   //                          .readdata
		.i_waitrequest                       (nios2_gen2_instruction_master_waitrequest),                //                          .waitrequest
		.i_readdatavalid                     (nios2_gen2_instruction_master_readdatavalid),              //                          .readdatavalid
		.irq                                 (nios2_gen2_irq_irq),                                       //                       irq.irq
		.debug_reset_request                 (nios2_gen2_debug_reset_request_reset),                     //       debug_reset_request.reset
		.debug_mem_slave_address             (mm_interconnect_0_nios2_gen2_debug_mem_slave_address),     //           debug_mem_slave.address
		.debug_mem_slave_byteenable          (mm_interconnect_0_nios2_gen2_debug_mem_slave_byteenable),  //                          .byteenable
		.debug_mem_slave_debugaccess         (mm_interconnect_0_nios2_gen2_debug_mem_slave_debugaccess), //                          .debugaccess
		.debug_mem_slave_read                (mm_interconnect_0_nios2_gen2_debug_mem_slave_read),        //                          .read
		.debug_mem_slave_readdata            (mm_interconnect_0_nios2_gen2_debug_mem_slave_readdata),    //                          .readdata
		.debug_mem_slave_waitrequest         (mm_interconnect_0_nios2_gen2_debug_mem_slave_waitrequest), //                          .waitrequest
		.debug_mem_slave_write               (mm_interconnect_0_nios2_gen2_debug_mem_slave_write),       //                          .write
		.debug_mem_slave_writedata           (mm_interconnect_0_nios2_gen2_debug_mem_slave_writedata),   //                          .writedata
		.dummy_ci_port                       ()                                                          // custom_instruction_master.readra
	);

	nios_system_onchip_memory onchip_memory (
		.clk        (altpll_sys_c0_clk),                             //   clk1.clk
		.address    (mm_interconnect_0_onchip_memory_s1_address),    //     s1.address
		.clken      (mm_interconnect_0_onchip_memory_s1_clken),      //       .clken
		.chipselect (mm_interconnect_0_onchip_memory_s1_chipselect), //       .chipselect
		.write      (mm_interconnect_0_onchip_memory_s1_write),      //       .write
		.readdata   (mm_interconnect_0_onchip_memory_s1_readdata),   //       .readdata
		.writedata  (mm_interconnect_0_onchip_memory_s1_writedata),  //       .writedata
		.byteenable (mm_interconnect_0_onchip_memory_s1_byteenable), //       .byteenable
		.reset      (rst_controller_002_reset_out_reset),            // reset1.reset
		.reset_req  (rst_controller_002_reset_out_reset_req)         //       .reset_req
	);

	nios_system_scd_3v3_poweron_n scd_3v3_poweron_n (
		.clk        (altpll_sys_c1_clk),                                 //                 clk.clk
		.reset_n    (~rst_controller_reset_out_reset),                   //               reset.reset_n
		.address    (mm_interconnect_1_scd_3v3_poweron_n_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_1_scd_3v3_poweron_n_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_1_scd_3v3_poweron_n_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_1_scd_3v3_poweron_n_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_1_scd_3v3_poweron_n_s1_readdata),   //                    .readdata
		.out_port   (scd_3v3_poweron_n_external_connection_export)       // external_connection.export
	);

	nios_system_switch switch (
		.clk      (altpll_sys_c1_clk),                    //                 clk.clk
		.reset_n  (~rst_controller_reset_out_reset),      //               reset.reset_n
		.address  (mm_interconnect_1_switch_s1_address),  //                  s1.address
		.readdata (mm_interconnect_1_switch_s1_readdata), //                    .readdata
		.in_port  (switch_external_connection_export)     // external_connection.export
	);

	nios_system_sysid_qsys sysid_qsys (
		.clock    (altpll_sys_c1_clk),                                   //           clk.clk
		.reset_n  (~rst_controller_reset_out_reset),                     //         reset.reset_n
		.readdata (mm_interconnect_1_sysid_qsys_control_slave_readdata), // control_slave.readdata
		.address  (mm_interconnect_1_sysid_qsys_control_slave_address)   //              .address
	);

	nios_system_timer timer (
		.clk        (altpll_sys_c1_clk),                     //   clk.clk
		.reset_n    (~rst_controller_reset_out_reset),       // reset.reset_n
		.address    (mm_interconnect_1_timer_s1_address),    //    s1.address
		.writedata  (mm_interconnect_1_timer_s1_writedata),  //      .writedata
		.readdata   (mm_interconnect_1_timer_s1_readdata),   //      .readdata
		.chipselect (mm_interconnect_1_timer_s1_chipselect), //      .chipselect
		.write_n    (~mm_interconnect_1_timer_s1_write),     //      .write_n
		.irq        (irq_synchronizer_002_receiver_irq)      //   irq.irq
	);

	nios_system_tmd_status tmd_status (
		.clk      (altpll_sys_c1_clk),                        //                 clk.clk
		.reset_n  (~rst_controller_reset_out_reset),          //               reset.reset_n
		.address  (mm_interconnect_1_tmd_status_s1_address),  //                  s1.address
		.readdata (mm_interconnect_1_tmd_status_s1_readdata), //                    .readdata
		.in_port  (tmd_status_external_connection_export)     // external_connection.export
	);

	nios_system_uart uart (
		.clk           (altpll_sys_c1_clk),                       //                 clk.clk
		.reset_n       (~rst_controller_reset_out_reset),         //               reset.reset_n
		.address       (mm_interconnect_1_uart_s1_address),       //                  s1.address
		.begintransfer (mm_interconnect_1_uart_s1_begintransfer), //                    .begintransfer
		.chipselect    (mm_interconnect_1_uart_s1_chipselect),    //                    .chipselect
		.read_n        (~mm_interconnect_1_uart_s1_read),         //                    .read_n
		.write_n       (~mm_interconnect_1_uart_s1_write),        //                    .write_n
		.writedata     (mm_interconnect_1_uart_s1_writedata),     //                    .writedata
		.readdata      (mm_interconnect_1_uart_s1_readdata),      //                    .readdata
		.dataavailable (),                                        //                    .dataavailable
		.readyfordata  (),                                        //                    .readyfordata
		.rxd           (uart_external_connection_rxd),            // external_connection.export
		.txd           (uart_external_connection_txd),            //                    .export
		.cts_n         (uart_external_connection_cts_n),          //                    .export
		.rts_n         (uart_external_connection_rts_n),          //                    .export
		.irq           (irq_synchronizer_001_receiver_irq)        //                 irq.irq
	);

	nios_system_mm_interconnect_0 mm_interconnect_0 (
		.altpll_sys_c0_clk                                            (altpll_sys_c0_clk),                                              //                                          altpll_sys_c0.clk
		.clk_50M_clk_clk                                              (clk_clk),                                                        //                                            clk_50M_clk.clk
		.altpll_sys_inclk_interface_reset_reset_bridge_in_reset_reset (rst_controller_001_reset_out_reset),                             // altpll_sys_inclk_interface_reset_reset_bridge_in_reset.reset
		.jtag_uart_reset_reset_bridge_in_reset_reset                  (rst_controller_002_reset_out_reset),                             //                  jtag_uart_reset_reset_bridge_in_reset.reset
		.nios2_gen2_reset_reset_bridge_in_reset_reset                 (rst_controller_003_reset_out_reset),                             //                 nios2_gen2_reset_reset_bridge_in_reset.reset
		.nios2_gen2_data_master_address                               (nios2_gen2_data_master_address),                                 //                                 nios2_gen2_data_master.address
		.nios2_gen2_data_master_waitrequest                           (nios2_gen2_data_master_waitrequest),                             //                                                       .waitrequest
		.nios2_gen2_data_master_byteenable                            (nios2_gen2_data_master_byteenable),                              //                                                       .byteenable
		.nios2_gen2_data_master_read                                  (nios2_gen2_data_master_read),                                    //                                                       .read
		.nios2_gen2_data_master_readdata                              (nios2_gen2_data_master_readdata),                                //                                                       .readdata
		.nios2_gen2_data_master_readdatavalid                         (nios2_gen2_data_master_readdatavalid),                           //                                                       .readdatavalid
		.nios2_gen2_data_master_write                                 (nios2_gen2_data_master_write),                                   //                                                       .write
		.nios2_gen2_data_master_writedata                             (nios2_gen2_data_master_writedata),                               //                                                       .writedata
		.nios2_gen2_data_master_debugaccess                           (nios2_gen2_data_master_debugaccess),                             //                                                       .debugaccess
		.nios2_gen2_instruction_master_address                        (nios2_gen2_instruction_master_address),                          //                          nios2_gen2_instruction_master.address
		.nios2_gen2_instruction_master_waitrequest                    (nios2_gen2_instruction_master_waitrequest),                      //                                                       .waitrequest
		.nios2_gen2_instruction_master_read                           (nios2_gen2_instruction_master_read),                             //                                                       .read
		.nios2_gen2_instruction_master_readdata                       (nios2_gen2_instruction_master_readdata),                         //                                                       .readdata
		.nios2_gen2_instruction_master_readdatavalid                  (nios2_gen2_instruction_master_readdatavalid),                    //                                                       .readdatavalid
		.altpll_sys_pll_slave_address                                 (mm_interconnect_0_altpll_sys_pll_slave_address),                 //                                   altpll_sys_pll_slave.address
		.altpll_sys_pll_slave_write                                   (mm_interconnect_0_altpll_sys_pll_slave_write),                   //                                                       .write
		.altpll_sys_pll_slave_read                                    (mm_interconnect_0_altpll_sys_pll_slave_read),                    //                                                       .read
		.altpll_sys_pll_slave_readdata                                (mm_interconnect_0_altpll_sys_pll_slave_readdata),                //                                                       .readdata
		.altpll_sys_pll_slave_writedata                               (mm_interconnect_0_altpll_sys_pll_slave_writedata),               //                                                       .writedata
		.ir_rx_avalon_slave_write                                     (mm_interconnect_0_ir_rx_avalon_slave_write),                     //                                     ir_rx_avalon_slave.write
		.ir_rx_avalon_slave_read                                      (mm_interconnect_0_ir_rx_avalon_slave_read),                      //                                                       .read
		.ir_rx_avalon_slave_readdata                                  (mm_interconnect_0_ir_rx_avalon_slave_readdata),                  //                                                       .readdata
		.ir_rx_avalon_slave_writedata                                 (mm_interconnect_0_ir_rx_avalon_slave_writedata),                 //                                                       .writedata
		.ir_rx_avalon_slave_chipselect                                (mm_interconnect_0_ir_rx_avalon_slave_chipselect),                //                                                       .chipselect
		.jtag_uart_avalon_jtag_slave_address                          (mm_interconnect_0_jtag_uart_avalon_jtag_slave_address),          //                            jtag_uart_avalon_jtag_slave.address
		.jtag_uart_avalon_jtag_slave_write                            (mm_interconnect_0_jtag_uart_avalon_jtag_slave_write),            //                                                       .write
		.jtag_uart_avalon_jtag_slave_read                             (mm_interconnect_0_jtag_uart_avalon_jtag_slave_read),             //                                                       .read
		.jtag_uart_avalon_jtag_slave_readdata                         (mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata),         //                                                       .readdata
		.jtag_uart_avalon_jtag_slave_writedata                        (mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata),        //                                                       .writedata
		.jtag_uart_avalon_jtag_slave_waitrequest                      (mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest),      //                                                       .waitrequest
		.jtag_uart_avalon_jtag_slave_chipselect                       (mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect),       //                                                       .chipselect
		.mm_clock_crossing_bridge_io_s0_address                       (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_address),       //                         mm_clock_crossing_bridge_io_s0.address
		.mm_clock_crossing_bridge_io_s0_write                         (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_write),         //                                                       .write
		.mm_clock_crossing_bridge_io_s0_read                          (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_read),          //                                                       .read
		.mm_clock_crossing_bridge_io_s0_readdata                      (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_readdata),      //                                                       .readdata
		.mm_clock_crossing_bridge_io_s0_writedata                     (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_writedata),     //                                                       .writedata
		.mm_clock_crossing_bridge_io_s0_burstcount                    (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_burstcount),    //                                                       .burstcount
		.mm_clock_crossing_bridge_io_s0_byteenable                    (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_byteenable),    //                                                       .byteenable
		.mm_clock_crossing_bridge_io_s0_readdatavalid                 (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_readdatavalid), //                                                       .readdatavalid
		.mm_clock_crossing_bridge_io_s0_waitrequest                   (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_waitrequest),   //                                                       .waitrequest
		.mm_clock_crossing_bridge_io_s0_debugaccess                   (mm_interconnect_0_mm_clock_crossing_bridge_io_s0_debugaccess),   //                                                       .debugaccess
		.nios2_gen2_debug_mem_slave_address                           (mm_interconnect_0_nios2_gen2_debug_mem_slave_address),           //                             nios2_gen2_debug_mem_slave.address
		.nios2_gen2_debug_mem_slave_write                             (mm_interconnect_0_nios2_gen2_debug_mem_slave_write),             //                                                       .write
		.nios2_gen2_debug_mem_slave_read                              (mm_interconnect_0_nios2_gen2_debug_mem_slave_read),              //                                                       .read
		.nios2_gen2_debug_mem_slave_readdata                          (mm_interconnect_0_nios2_gen2_debug_mem_slave_readdata),          //                                                       .readdata
		.nios2_gen2_debug_mem_slave_writedata                         (mm_interconnect_0_nios2_gen2_debug_mem_slave_writedata),         //                                                       .writedata
		.nios2_gen2_debug_mem_slave_byteenable                        (mm_interconnect_0_nios2_gen2_debug_mem_slave_byteenable),        //                                                       .byteenable
		.nios2_gen2_debug_mem_slave_waitrequest                       (mm_interconnect_0_nios2_gen2_debug_mem_slave_waitrequest),       //                                                       .waitrequest
		.nios2_gen2_debug_mem_slave_debugaccess                       (mm_interconnect_0_nios2_gen2_debug_mem_slave_debugaccess),       //                                                       .debugaccess
		.onchip_memory_s1_address                                     (mm_interconnect_0_onchip_memory_s1_address),                     //                                       onchip_memory_s1.address
		.onchip_memory_s1_write                                       (mm_interconnect_0_onchip_memory_s1_write),                       //                                                       .write
		.onchip_memory_s1_readdata                                    (mm_interconnect_0_onchip_memory_s1_readdata),                    //                                                       .readdata
		.onchip_memory_s1_writedata                                   (mm_interconnect_0_onchip_memory_s1_writedata),                   //                                                       .writedata
		.onchip_memory_s1_byteenable                                  (mm_interconnect_0_onchip_memory_s1_byteenable),                  //                                                       .byteenable
		.onchip_memory_s1_chipselect                                  (mm_interconnect_0_onchip_memory_s1_chipselect),                  //                                                       .chipselect
		.onchip_memory_s1_clken                                       (mm_interconnect_0_onchip_memory_s1_clken)                        //                                                       .clken
	);

	nios_system_mm_interconnect_1 mm_interconnect_1 (
		.altpll_sys_c1_clk                                                (altpll_sys_c1_clk),                                        //                                              altpll_sys_c1.clk
		.mm_clock_crossing_bridge_io_m0_reset_reset_bridge_in_reset_reset (rst_controller_reset_out_reset),                           // mm_clock_crossing_bridge_io_m0_reset_reset_bridge_in_reset.reset
		.mm_clock_crossing_bridge_io_m0_address                           (mm_clock_crossing_bridge_io_m0_address),                   //                             mm_clock_crossing_bridge_io_m0.address
		.mm_clock_crossing_bridge_io_m0_waitrequest                       (mm_clock_crossing_bridge_io_m0_waitrequest),               //                                                           .waitrequest
		.mm_clock_crossing_bridge_io_m0_burstcount                        (mm_clock_crossing_bridge_io_m0_burstcount),                //                                                           .burstcount
		.mm_clock_crossing_bridge_io_m0_byteenable                        (mm_clock_crossing_bridge_io_m0_byteenable),                //                                                           .byteenable
		.mm_clock_crossing_bridge_io_m0_read                              (mm_clock_crossing_bridge_io_m0_read),                      //                                                           .read
		.mm_clock_crossing_bridge_io_m0_readdata                          (mm_clock_crossing_bridge_io_m0_readdata),                  //                                                           .readdata
		.mm_clock_crossing_bridge_io_m0_readdatavalid                     (mm_clock_crossing_bridge_io_m0_readdatavalid),             //                                                           .readdatavalid
		.mm_clock_crossing_bridge_io_m0_write                             (mm_clock_crossing_bridge_io_m0_write),                     //                                                           .write
		.mm_clock_crossing_bridge_io_m0_writedata                         (mm_clock_crossing_bridge_io_m0_writedata),                 //                                                           .writedata
		.mm_clock_crossing_bridge_io_m0_debugaccess                       (mm_clock_crossing_bridge_io_m0_debugaccess),               //                                                           .debugaccess
		.adc_ltc2308_slave_address                                        (mm_interconnect_1_adc_ltc2308_slave_address),              //                                          adc_ltc2308_slave.address
		.adc_ltc2308_slave_write                                          (mm_interconnect_1_adc_ltc2308_slave_write),                //                                                           .write
		.adc_ltc2308_slave_read                                           (mm_interconnect_1_adc_ltc2308_slave_read),                 //                                                           .read
		.adc_ltc2308_slave_readdata                                       (mm_interconnect_1_adc_ltc2308_slave_readdata),             //                                                           .readdata
		.adc_ltc2308_slave_writedata                                      (mm_interconnect_1_adc_ltc2308_slave_writedata),            //                                                           .writedata
		.adc_ltc2308_slave_chipselect                                     (mm_interconnect_1_adc_ltc2308_slave_chipselect),           //                                                           .chipselect
		.buzzer_s1_address                                                (mm_interconnect_1_buzzer_s1_address),                      //                                                  buzzer_s1.address
		.buzzer_s1_write                                                  (mm_interconnect_1_buzzer_s1_write),                        //                                                           .write
		.buzzer_s1_readdata                                               (mm_interconnect_1_buzzer_s1_readdata),                     //                                                           .readdata
		.buzzer_s1_writedata                                              (mm_interconnect_1_buzzer_s1_writedata),                    //                                                           .writedata
		.buzzer_s1_chipselect                                             (mm_interconnect_1_buzzer_s1_chipselect),                   //                                                           .chipselect
		.dc_motor_left_avalon_slave_address                               (mm_interconnect_1_dc_motor_left_avalon_slave_address),     //                                 dc_motor_left_avalon_slave.address
		.dc_motor_left_avalon_slave_write                                 (mm_interconnect_1_dc_motor_left_avalon_slave_write),       //                                                           .write
		.dc_motor_left_avalon_slave_read                                  (mm_interconnect_1_dc_motor_left_avalon_slave_read),        //                                                           .read
		.dc_motor_left_avalon_slave_readdata                              (mm_interconnect_1_dc_motor_left_avalon_slave_readdata),    //                                                           .readdata
		.dc_motor_left_avalon_slave_writedata                             (mm_interconnect_1_dc_motor_left_avalon_slave_writedata),   //                                                           .writedata
		.dc_motor_left_avalon_slave_chipselect                            (mm_interconnect_1_dc_motor_left_avalon_slave_chipselect),  //                                                           .chipselect
		.dc_motor_right_avalon_slave_address                              (mm_interconnect_1_dc_motor_right_avalon_slave_address),    //                                dc_motor_right_avalon_slave.address
		.dc_motor_right_avalon_slave_write                                (mm_interconnect_1_dc_motor_right_avalon_slave_write),      //                                                           .write
		.dc_motor_right_avalon_slave_read                                 (mm_interconnect_1_dc_motor_right_avalon_slave_read),       //                                                           .read
		.dc_motor_right_avalon_slave_readdata                             (mm_interconnect_1_dc_motor_right_avalon_slave_readdata),   //                                                           .readdata
		.dc_motor_right_avalon_slave_writedata                            (mm_interconnect_1_dc_motor_right_avalon_slave_writedata),  //                                                           .writedata
		.dc_motor_right_avalon_slave_chipselect                           (mm_interconnect_1_dc_motor_right_avalon_slave_chipselect), //                                                           .chipselect
		.ir_led_on_s1_address                                             (mm_interconnect_1_ir_led_on_s1_address),                   //                                               ir_led_on_s1.address
		.ir_led_on_s1_write                                               (mm_interconnect_1_ir_led_on_s1_write),                     //                                                           .write
		.ir_led_on_s1_readdata                                            (mm_interconnect_1_ir_led_on_s1_readdata),                  //                                                           .readdata
		.ir_led_on_s1_writedata                                           (mm_interconnect_1_ir_led_on_s1_writedata),                 //                                                           .writedata
		.ir_led_on_s1_chipselect                                          (mm_interconnect_1_ir_led_on_s1_chipselect),                //                                                           .chipselect
		.key_s1_address                                                   (mm_interconnect_1_key_s1_address),                         //                                                     key_s1.address
		.key_s1_readdata                                                  (mm_interconnect_1_key_s1_readdata),                        //                                                           .readdata
		.led_s1_address                                                   (mm_interconnect_1_led_s1_address),                         //                                                     led_s1.address
		.led_s1_write                                                     (mm_interconnect_1_led_s1_write),                           //                                                           .write
		.led_s1_readdata                                                  (mm_interconnect_1_led_s1_readdata),                        //                                                           .readdata
		.led_s1_writedata                                                 (mm_interconnect_1_led_s1_writedata),                       //                                                           .writedata
		.led_s1_chipselect                                                (mm_interconnect_1_led_s1_chipselect),                      //                                                           .chipselect
		.light_left_s1_address                                            (mm_interconnect_1_light_left_s1_address),                  //                                              light_left_s1.address
		.light_left_s1_write                                              (mm_interconnect_1_light_left_s1_write),                    //                                                           .write
		.light_left_s1_readdata                                           (mm_interconnect_1_light_left_s1_readdata),                 //                                                           .readdata
		.light_left_s1_writedata                                          (mm_interconnect_1_light_left_s1_writedata),                //                                                           .writedata
		.light_left_s1_chipselect                                         (mm_interconnect_1_light_left_s1_chipselect),               //                                                           .chipselect
		.light_right_s1_address                                           (mm_interconnect_1_light_right_s1_address),                 //                                             light_right_s1.address
		.light_right_s1_write                                             (mm_interconnect_1_light_right_s1_write),                   //                                                           .write
		.light_right_s1_readdata                                          (mm_interconnect_1_light_right_s1_readdata),                //                                                           .readdata
		.light_right_s1_writedata                                         (mm_interconnect_1_light_right_s1_writedata),               //                                                           .writedata
		.light_right_s1_chipselect                                        (mm_interconnect_1_light_right_s1_chipselect),              //                                                           .chipselect
		.scd_3v3_poweron_n_s1_address                                     (mm_interconnect_1_scd_3v3_poweron_n_s1_address),           //                                       scd_3v3_poweron_n_s1.address
		.scd_3v3_poweron_n_s1_write                                       (mm_interconnect_1_scd_3v3_poweron_n_s1_write),             //                                                           .write
		.scd_3v3_poweron_n_s1_readdata                                    (mm_interconnect_1_scd_3v3_poweron_n_s1_readdata),          //                                                           .readdata
		.scd_3v3_poweron_n_s1_writedata                                   (mm_interconnect_1_scd_3v3_poweron_n_s1_writedata),         //                                                           .writedata
		.scd_3v3_poweron_n_s1_chipselect                                  (mm_interconnect_1_scd_3v3_poweron_n_s1_chipselect),        //                                                           .chipselect
		.switch_s1_address                                                (mm_interconnect_1_switch_s1_address),                      //                                                  switch_s1.address
		.switch_s1_readdata                                               (mm_interconnect_1_switch_s1_readdata),                     //                                                           .readdata
		.sysid_qsys_control_slave_address                                 (mm_interconnect_1_sysid_qsys_control_slave_address),       //                                   sysid_qsys_control_slave.address
		.sysid_qsys_control_slave_readdata                                (mm_interconnect_1_sysid_qsys_control_slave_readdata),      //                                                           .readdata
		.timer_s1_address                                                 (mm_interconnect_1_timer_s1_address),                       //                                                   timer_s1.address
		.timer_s1_write                                                   (mm_interconnect_1_timer_s1_write),                         //                                                           .write
		.timer_s1_readdata                                                (mm_interconnect_1_timer_s1_readdata),                      //                                                           .readdata
		.timer_s1_writedata                                               (mm_interconnect_1_timer_s1_writedata),                     //                                                           .writedata
		.timer_s1_chipselect                                              (mm_interconnect_1_timer_s1_chipselect),                    //                                                           .chipselect
		.tmd_status_s1_address                                            (mm_interconnect_1_tmd_status_s1_address),                  //                                              tmd_status_s1.address
		.tmd_status_s1_readdata                                           (mm_interconnect_1_tmd_status_s1_readdata),                 //                                                           .readdata
		.uart_s1_address                                                  (mm_interconnect_1_uart_s1_address),                        //                                                    uart_s1.address
		.uart_s1_write                                                    (mm_interconnect_1_uart_s1_write),                          //                                                           .write
		.uart_s1_read                                                     (mm_interconnect_1_uart_s1_read),                           //                                                           .read
		.uart_s1_readdata                                                 (mm_interconnect_1_uart_s1_readdata),                       //                                                           .readdata
		.uart_s1_writedata                                                (mm_interconnect_1_uart_s1_writedata),                      //                                                           .writedata
		.uart_s1_begintransfer                                            (mm_interconnect_1_uart_s1_begintransfer),                  //                                                           .begintransfer
		.uart_s1_chipselect                                               (mm_interconnect_1_uart_s1_chipselect)                      //                                                           .chipselect
	);

	nios_system_irq_mapper irq_mapper (
		.clk           (altpll_sys_c0_clk),                  //       clk.clk
		.reset         (rst_controller_003_reset_out_reset), // clk_reset.reset
		.receiver0_irq (irq_mapper_receiver0_irq),           // receiver0.irq
		.receiver1_irq (irq_mapper_receiver1_irq),           // receiver1.irq
		.receiver2_irq (irq_mapper_receiver2_irq),           // receiver2.irq
		.receiver3_irq (irq_mapper_receiver3_irq),           // receiver3.irq
		.sender_irq    (nios2_gen2_irq_irq)                  //    sender.irq
	);

	altera_irq_clock_crosser #(
		.IRQ_WIDTH (1)
	) irq_synchronizer (
		.receiver_clk   (clk_clk),                            //       receiver_clk.clk
		.sender_clk     (altpll_sys_c0_clk),                  //         sender_clk.clk
		.receiver_reset (rst_controller_001_reset_out_reset), // receiver_clk_reset.reset
		.sender_reset   (rst_controller_003_reset_out_reset), //   sender_clk_reset.reset
		.receiver_irq   (irq_synchronizer_receiver_irq),      //           receiver.irq
		.sender_irq     (irq_mapper_receiver0_irq)            //             sender.irq
	);

	altera_irq_clock_crosser #(
		.IRQ_WIDTH (1)
	) irq_synchronizer_001 (
		.receiver_clk   (altpll_sys_c1_clk),                  //       receiver_clk.clk
		.sender_clk     (altpll_sys_c0_clk),                  //         sender_clk.clk
		.receiver_reset (rst_controller_reset_out_reset),     // receiver_clk_reset.reset
		.sender_reset   (rst_controller_003_reset_out_reset), //   sender_clk_reset.reset
		.receiver_irq   (irq_synchronizer_001_receiver_irq),  //           receiver.irq
		.sender_irq     (irq_mapper_receiver1_irq)            //             sender.irq
	);

	altera_irq_clock_crosser #(
		.IRQ_WIDTH (1)
	) irq_synchronizer_002 (
		.receiver_clk   (altpll_sys_c1_clk),                  //       receiver_clk.clk
		.sender_clk     (altpll_sys_c0_clk),                  //         sender_clk.clk
		.receiver_reset (rst_controller_reset_out_reset),     // receiver_clk_reset.reset
		.sender_reset   (rst_controller_003_reset_out_reset), //   sender_clk_reset.reset
		.receiver_irq   (irq_synchronizer_002_receiver_irq),  //           receiver.irq
		.sender_irq     (irq_mapper_receiver2_irq)            //             sender.irq
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller (
		.reset_in0      (~reset_reset_n),                 // reset_in0.reset
		.clk            (altpll_sys_c1_clk),              //       clk.clk
		.reset_out      (rst_controller_reset_out_reset), // reset_out.reset
		.reset_req      (),                               // (terminated)
		.reset_req_in0  (1'b0),                           // (terminated)
		.reset_in1      (1'b0),                           // (terminated)
		.reset_req_in1  (1'b0),                           // (terminated)
		.reset_in2      (1'b0),                           // (terminated)
		.reset_req_in2  (1'b0),                           // (terminated)
		.reset_in3      (1'b0),                           // (terminated)
		.reset_req_in3  (1'b0),                           // (terminated)
		.reset_in4      (1'b0),                           // (terminated)
		.reset_req_in4  (1'b0),                           // (terminated)
		.reset_in5      (1'b0),                           // (terminated)
		.reset_req_in5  (1'b0),                           // (terminated)
		.reset_in6      (1'b0),                           // (terminated)
		.reset_req_in6  (1'b0),                           // (terminated)
		.reset_in7      (1'b0),                           // (terminated)
		.reset_req_in7  (1'b0),                           // (terminated)
		.reset_in8      (1'b0),                           // (terminated)
		.reset_req_in8  (1'b0),                           // (terminated)
		.reset_in9      (1'b0),                           // (terminated)
		.reset_req_in9  (1'b0),                           // (terminated)
		.reset_in10     (1'b0),                           // (terminated)
		.reset_req_in10 (1'b0),                           // (terminated)
		.reset_in11     (1'b0),                           // (terminated)
		.reset_req_in11 (1'b0),                           // (terminated)
		.reset_in12     (1'b0),                           // (terminated)
		.reset_req_in12 (1'b0),                           // (terminated)
		.reset_in13     (1'b0),                           // (terminated)
		.reset_req_in13 (1'b0),                           // (terminated)
		.reset_in14     (1'b0),                           // (terminated)
		.reset_req_in14 (1'b0),                           // (terminated)
		.reset_in15     (1'b0),                           // (terminated)
		.reset_req_in15 (1'b0)                            // (terminated)
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_001 (
		.reset_in0      (~reset_reset_n),                     // reset_in0.reset
		.clk            (clk_clk),                            //       clk.clk
		.reset_out      (rst_controller_001_reset_out_reset), // reset_out.reset
		.reset_req      (),                                   // (terminated)
		.reset_req_in0  (1'b0),                               // (terminated)
		.reset_in1      (1'b0),                               // (terminated)
		.reset_req_in1  (1'b0),                               // (terminated)
		.reset_in2      (1'b0),                               // (terminated)
		.reset_req_in2  (1'b0),                               // (terminated)
		.reset_in3      (1'b0),                               // (terminated)
		.reset_req_in3  (1'b0),                               // (terminated)
		.reset_in4      (1'b0),                               // (terminated)
		.reset_req_in4  (1'b0),                               // (terminated)
		.reset_in5      (1'b0),                               // (terminated)
		.reset_req_in5  (1'b0),                               // (terminated)
		.reset_in6      (1'b0),                               // (terminated)
		.reset_req_in6  (1'b0),                               // (terminated)
		.reset_in7      (1'b0),                               // (terminated)
		.reset_req_in7  (1'b0),                               // (terminated)
		.reset_in8      (1'b0),                               // (terminated)
		.reset_req_in8  (1'b0),                               // (terminated)
		.reset_in9      (1'b0),                               // (terminated)
		.reset_req_in9  (1'b0),                               // (terminated)
		.reset_in10     (1'b0),                               // (terminated)
		.reset_req_in10 (1'b0),                               // (terminated)
		.reset_in11     (1'b0),                               // (terminated)
		.reset_req_in11 (1'b0),                               // (terminated)
		.reset_in12     (1'b0),                               // (terminated)
		.reset_req_in12 (1'b0),                               // (terminated)
		.reset_in13     (1'b0),                               // (terminated)
		.reset_req_in13 (1'b0),                               // (terminated)
		.reset_in14     (1'b0),                               // (terminated)
		.reset_req_in14 (1'b0),                               // (terminated)
		.reset_in15     (1'b0),                               // (terminated)
		.reset_req_in15 (1'b0)                                // (terminated)
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (1),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_002 (
		.reset_in0      (~reset_reset_n),                         // reset_in0.reset
		.clk            (altpll_sys_c0_clk),                      //       clk.clk
		.reset_out      (rst_controller_002_reset_out_reset),     // reset_out.reset
		.reset_req      (rst_controller_002_reset_out_reset_req), //          .reset_req
		.reset_req_in0  (1'b0),                                   // (terminated)
		.reset_in1      (1'b0),                                   // (terminated)
		.reset_req_in1  (1'b0),                                   // (terminated)
		.reset_in2      (1'b0),                                   // (terminated)
		.reset_req_in2  (1'b0),                                   // (terminated)
		.reset_in3      (1'b0),                                   // (terminated)
		.reset_req_in3  (1'b0),                                   // (terminated)
		.reset_in4      (1'b0),                                   // (terminated)
		.reset_req_in4  (1'b0),                                   // (terminated)
		.reset_in5      (1'b0),                                   // (terminated)
		.reset_req_in5  (1'b0),                                   // (terminated)
		.reset_in6      (1'b0),                                   // (terminated)
		.reset_req_in6  (1'b0),                                   // (terminated)
		.reset_in7      (1'b0),                                   // (terminated)
		.reset_req_in7  (1'b0),                                   // (terminated)
		.reset_in8      (1'b0),                                   // (terminated)
		.reset_req_in8  (1'b0),                                   // (terminated)
		.reset_in9      (1'b0),                                   // (terminated)
		.reset_req_in9  (1'b0),                                   // (terminated)
		.reset_in10     (1'b0),                                   // (terminated)
		.reset_req_in10 (1'b0),                                   // (terminated)
		.reset_in11     (1'b0),                                   // (terminated)
		.reset_req_in11 (1'b0),                                   // (terminated)
		.reset_in12     (1'b0),                                   // (terminated)
		.reset_req_in12 (1'b0),                                   // (terminated)
		.reset_in13     (1'b0),                                   // (terminated)
		.reset_req_in13 (1'b0),                                   // (terminated)
		.reset_in14     (1'b0),                                   // (terminated)
		.reset_req_in14 (1'b0),                                   // (terminated)
		.reset_in15     (1'b0),                                   // (terminated)
		.reset_req_in15 (1'b0)                                    // (terminated)
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (1),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_003 (
		.reset_in0      (nios2_gen2_debug_reset_request_reset),   // reset_in0.reset
		.clk            (altpll_sys_c0_clk),                      //       clk.clk
		.reset_out      (rst_controller_003_reset_out_reset),     // reset_out.reset
		.reset_req      (rst_controller_003_reset_out_reset_req), //          .reset_req
		.reset_req_in0  (1'b0),                                   // (terminated)
		.reset_in1      (1'b0),                                   // (terminated)
		.reset_req_in1  (1'b0),                                   // (terminated)
		.reset_in2      (1'b0),                                   // (terminated)
		.reset_req_in2  (1'b0),                                   // (terminated)
		.reset_in3      (1'b0),                                   // (terminated)
		.reset_req_in3  (1'b0),                                   // (terminated)
		.reset_in4      (1'b0),                                   // (terminated)
		.reset_req_in4  (1'b0),                                   // (terminated)
		.reset_in5      (1'b0),                                   // (terminated)
		.reset_req_in5  (1'b0),                                   // (terminated)
		.reset_in6      (1'b0),                                   // (terminated)
		.reset_req_in6  (1'b0),                                   // (terminated)
		.reset_in7      (1'b0),                                   // (terminated)
		.reset_req_in7  (1'b0),                                   // (terminated)
		.reset_in8      (1'b0),                                   // (terminated)
		.reset_req_in8  (1'b0),                                   // (terminated)
		.reset_in9      (1'b0),                                   // (terminated)
		.reset_req_in9  (1'b0),                                   // (terminated)
		.reset_in10     (1'b0),                                   // (terminated)
		.reset_req_in10 (1'b0),                                   // (terminated)
		.reset_in11     (1'b0),                                   // (terminated)
		.reset_req_in11 (1'b0),                                   // (terminated)
		.reset_in12     (1'b0),                                   // (terminated)
		.reset_req_in12 (1'b0),                                   // (terminated)
		.reset_in13     (1'b0),                                   // (terminated)
		.reset_req_in13 (1'b0),                                   // (terminated)
		.reset_in14     (1'b0),                                   // (terminated)
		.reset_req_in14 (1'b0),                                   // (terminated)
		.reset_in15     (1'b0),                                   // (terminated)
		.reset_req_in15 (1'b0)                                    // (terminated)
	);

endmodule
