/*
 * Sensor.h
 *
 *  Created on: 2016/3/15
 *      Author: User
 */

#ifndef SENSOR_H_
#define SENSOR_H_


#include "terasic_includes.h"
#define SENSOR_NUM			7
#define ADC_CHANNEL_NUM		8


class CSensor {
protected:
	bool ReadADC(alt_u16 szAdc[ADC_CHANNEL_NUM]);
public:
	CSensor();
	virtual ~CSensor();

	bool ReadLineSenorAndInputPower(alt_u16 szAdc[SENSOR_NUM], alt_u16 *pmV);
	bool ReadLineSenor(alt_u16 szAdc[SENSOR_NUM]);
	bool ReadInputPower(alt_u16 *pmV);
	void DumpLineSenor(void);
	void DumpLineSenor(alt_u16 szAdc[SENSOR_NUM]);
	void Test(void);
	void Test2(void);
};



#endif /* SENSOR_H_ */
