
module Qsys (
	altpll_areset_conduit_export,
	altpll_locked_conduit_export,
	altpll_phasedone_conduit_export,
	altpll_sdram_clk,
	bts_tmd_connect_state_external_connection_export,
	bts_tmd_external_connection_rxd,
	bts_tmd_external_connection_txd,
	bts_tmd_external_connection_cts_n,
	bts_tmd_external_connection_rts_n,
	buzzer_out_external_connection_export,
	car_led_external_connection_export,
	car_voltage_data_external_connection_export,
	clk_clk,
	dc_motor_left_conduit_end_motor_p,
	dc_motor_left_conduit_end_motor_n,
	dc_motor_right_conduit_end_motor_p,
	dc_motor_right_conduit_end_motor_n,
	epcs_controller_external_dclk,
	epcs_controller_external_sce,
	epcs_controller_external_sdo,
	epcs_controller_external_data0,
	reset_reset_n,
	sdram_wire_addr,
	sdram_wire_ba,
	sdram_wire_cas_n,
	sdram_wire_cke,
	sdram_wire_cs_n,
	sdram_wire_dq,
	sdram_wire_dqm,
	sdram_wire_ras_n,
	sdram_wire_we_n);	

	input		altpll_areset_conduit_export;
	output		altpll_locked_conduit_export;
	output		altpll_phasedone_conduit_export;
	output		altpll_sdram_clk;
	input		bts_tmd_connect_state_external_connection_export;
	input		bts_tmd_external_connection_rxd;
	output		bts_tmd_external_connection_txd;
	input		bts_tmd_external_connection_cts_n;
	output		bts_tmd_external_connection_rts_n;
	output		buzzer_out_external_connection_export;
	output	[1:0]	car_led_external_connection_export;
	input	[11:0]	car_voltage_data_external_connection_export;
	input		clk_clk;
	output		dc_motor_left_conduit_end_motor_p;
	output		dc_motor_left_conduit_end_motor_n;
	output		dc_motor_right_conduit_end_motor_p;
	output		dc_motor_right_conduit_end_motor_n;
	output		epcs_controller_external_dclk;
	output		epcs_controller_external_sce;
	output		epcs_controller_external_sdo;
	input		epcs_controller_external_data0;
	input		reset_reset_n;
	output	[12:0]	sdram_wire_addr;
	output	[1:0]	sdram_wire_ba;
	output		sdram_wire_cas_n;
	output		sdram_wire_cke;
	output		sdram_wire_cs_n;
	inout	[15:0]	sdram_wire_dq;
	output	[1:0]	sdram_wire_dqm;
	output		sdram_wire_ras_n;
	output		sdram_wire_we_n;
endmodule
