// Qsys.v

// Generated using ACDS version 15.1 193

`timescale 1 ps / 1 ps
module Qsys (
		input  wire        altpll_areset_conduit_export,                     //                     altpll_areset_conduit.export
		output wire        altpll_locked_conduit_export,                     //                     altpll_locked_conduit.export
		output wire        altpll_phasedone_conduit_export,                  //                  altpll_phasedone_conduit.export
		output wire        altpll_sdram_clk,                                 //                              altpll_sdram.clk
		input  wire        bts_tmd_connect_state_external_connection_export, // bts_tmd_connect_state_external_connection.export
		input  wire        bts_tmd_external_connection_rxd,                  //               bts_tmd_external_connection.rxd
		output wire        bts_tmd_external_connection_txd,                  //                                          .txd
		input  wire        bts_tmd_external_connection_cts_n,                //                                          .cts_n
		output wire        bts_tmd_external_connection_rts_n,                //                                          .rts_n
		output wire        buzzer_out_external_connection_export,            //            buzzer_out_external_connection.export
		output wire [1:0]  car_led_external_connection_export,               //               car_led_external_connection.export
		input  wire [11:0] car_voltage_data_external_connection_export,      //      car_voltage_data_external_connection.export
		input  wire        clk_clk,                                          //                                       clk.clk
		output wire        dc_motor_left_conduit_end_motor_p,                //                 dc_motor_left_conduit_end.motor_p
		output wire        dc_motor_left_conduit_end_motor_n,                //                                          .motor_n
		output wire        dc_motor_right_conduit_end_motor_p,               //                dc_motor_right_conduit_end.motor_p
		output wire        dc_motor_right_conduit_end_motor_n,               //                                          .motor_n
		output wire        epcs_controller_external_dclk,                    //                  epcs_controller_external.dclk
		output wire        epcs_controller_external_sce,                     //                                          .sce
		output wire        epcs_controller_external_sdo,                     //                                          .sdo
		input  wire        epcs_controller_external_data0,                   //                                          .data0
		input  wire        reset_reset_n,                                    //                                     reset.reset_n
		output wire [12:0] sdram_wire_addr,                                  //                                sdram_wire.addr
		output wire [1:0]  sdram_wire_ba,                                    //                                          .ba
		output wire        sdram_wire_cas_n,                                 //                                          .cas_n
		output wire        sdram_wire_cke,                                   //                                          .cke
		output wire        sdram_wire_cs_n,                                  //                                          .cs_n
		inout  wire [15:0] sdram_wire_dq,                                    //                                          .dq
		output wire [1:0]  sdram_wire_dqm,                                   //                                          .dqm
		output wire        sdram_wire_ras_n,                                 //                                          .ras_n
		output wire        sdram_wire_we_n                                   //                                          .we_n
	);

	wire         altpll_c0_clk;                                                  // altpll:c0 -> [bts_tmd:clk, bts_tmd_connect_state:clk, buzzer_out:clk, car_led:clk, car_voltage_data:clk, dc_motor_left:clk, dc_motor_right:clk, epcs_controller:clk, irq_mapper:clk, jtag_uart:clk, mm_interconnect_0:altpll_c0_clk, nios2_gen2_0:clk, rst_controller_001:clk, rst_controller_002:clk, sdram:clk, sysid_qsys:clock, timer_0:clk]
	wire  [31:0] nios2_gen2_0_data_master_readdata;                              // mm_interconnect_0:nios2_gen2_0_data_master_readdata -> nios2_gen2_0:d_readdata
	wire         nios2_gen2_0_data_master_waitrequest;                           // mm_interconnect_0:nios2_gen2_0_data_master_waitrequest -> nios2_gen2_0:d_waitrequest
	wire         nios2_gen2_0_data_master_debugaccess;                           // nios2_gen2_0:debug_mem_slave_debugaccess_to_roms -> mm_interconnect_0:nios2_gen2_0_data_master_debugaccess
	wire  [26:0] nios2_gen2_0_data_master_address;                               // nios2_gen2_0:d_address -> mm_interconnect_0:nios2_gen2_0_data_master_address
	wire   [3:0] nios2_gen2_0_data_master_byteenable;                            // nios2_gen2_0:d_byteenable -> mm_interconnect_0:nios2_gen2_0_data_master_byteenable
	wire         nios2_gen2_0_data_master_read;                                  // nios2_gen2_0:d_read -> mm_interconnect_0:nios2_gen2_0_data_master_read
	wire         nios2_gen2_0_data_master_readdatavalid;                         // mm_interconnect_0:nios2_gen2_0_data_master_readdatavalid -> nios2_gen2_0:d_readdatavalid
	wire         nios2_gen2_0_data_master_write;                                 // nios2_gen2_0:d_write -> mm_interconnect_0:nios2_gen2_0_data_master_write
	wire  [31:0] nios2_gen2_0_data_master_writedata;                             // nios2_gen2_0:d_writedata -> mm_interconnect_0:nios2_gen2_0_data_master_writedata
	wire  [31:0] nios2_gen2_0_instruction_master_readdata;                       // mm_interconnect_0:nios2_gen2_0_instruction_master_readdata -> nios2_gen2_0:i_readdata
	wire         nios2_gen2_0_instruction_master_waitrequest;                    // mm_interconnect_0:nios2_gen2_0_instruction_master_waitrequest -> nios2_gen2_0:i_waitrequest
	wire  [26:0] nios2_gen2_0_instruction_master_address;                        // nios2_gen2_0:i_address -> mm_interconnect_0:nios2_gen2_0_instruction_master_address
	wire         nios2_gen2_0_instruction_master_read;                           // nios2_gen2_0:i_read -> mm_interconnect_0:nios2_gen2_0_instruction_master_read
	wire         nios2_gen2_0_instruction_master_readdatavalid;                  // mm_interconnect_0:nios2_gen2_0_instruction_master_readdatavalid -> nios2_gen2_0:i_readdatavalid
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect;       // mm_interconnect_0:jtag_uart_avalon_jtag_slave_chipselect -> jtag_uart:av_chipselect
	wire  [31:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata;         // jtag_uart:av_readdata -> mm_interconnect_0:jtag_uart_avalon_jtag_slave_readdata
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest;      // jtag_uart:av_waitrequest -> mm_interconnect_0:jtag_uart_avalon_jtag_slave_waitrequest
	wire   [0:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_address;          // mm_interconnect_0:jtag_uart_avalon_jtag_slave_address -> jtag_uart:av_address
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_read;             // mm_interconnect_0:jtag_uart_avalon_jtag_slave_read -> jtag_uart:av_read_n
	wire         mm_interconnect_0_jtag_uart_avalon_jtag_slave_write;            // mm_interconnect_0:jtag_uart_avalon_jtag_slave_write -> jtag_uart:av_write_n
	wire  [31:0] mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata;        // mm_interconnect_0:jtag_uart_avalon_jtag_slave_writedata -> jtag_uart:av_writedata
	wire         mm_interconnect_0_dc_motor_left_avalon_slave_chipselect;        // mm_interconnect_0:dc_motor_left_avalon_slave_chipselect -> dc_motor_left:s_cs
	wire  [31:0] mm_interconnect_0_dc_motor_left_avalon_slave_readdata;          // dc_motor_left:s_readdata -> mm_interconnect_0:dc_motor_left_avalon_slave_readdata
	wire   [1:0] mm_interconnect_0_dc_motor_left_avalon_slave_address;           // mm_interconnect_0:dc_motor_left_avalon_slave_address -> dc_motor_left:s_address
	wire         mm_interconnect_0_dc_motor_left_avalon_slave_read;              // mm_interconnect_0:dc_motor_left_avalon_slave_read -> dc_motor_left:s_read
	wire         mm_interconnect_0_dc_motor_left_avalon_slave_write;             // mm_interconnect_0:dc_motor_left_avalon_slave_write -> dc_motor_left:s_write
	wire  [31:0] mm_interconnect_0_dc_motor_left_avalon_slave_writedata;         // mm_interconnect_0:dc_motor_left_avalon_slave_writedata -> dc_motor_left:s_writedata
	wire         mm_interconnect_0_dc_motor_right_avalon_slave_chipselect;       // mm_interconnect_0:dc_motor_right_avalon_slave_chipselect -> dc_motor_right:s_cs
	wire  [31:0] mm_interconnect_0_dc_motor_right_avalon_slave_readdata;         // dc_motor_right:s_readdata -> mm_interconnect_0:dc_motor_right_avalon_slave_readdata
	wire   [1:0] mm_interconnect_0_dc_motor_right_avalon_slave_address;          // mm_interconnect_0:dc_motor_right_avalon_slave_address -> dc_motor_right:s_address
	wire         mm_interconnect_0_dc_motor_right_avalon_slave_read;             // mm_interconnect_0:dc_motor_right_avalon_slave_read -> dc_motor_right:s_read
	wire         mm_interconnect_0_dc_motor_right_avalon_slave_write;            // mm_interconnect_0:dc_motor_right_avalon_slave_write -> dc_motor_right:s_write
	wire  [31:0] mm_interconnect_0_dc_motor_right_avalon_slave_writedata;        // mm_interconnect_0:dc_motor_right_avalon_slave_writedata -> dc_motor_right:s_writedata
	wire  [31:0] mm_interconnect_0_sysid_qsys_control_slave_readdata;            // sysid_qsys:readdata -> mm_interconnect_0:sysid_qsys_control_slave_readdata
	wire   [0:0] mm_interconnect_0_sysid_qsys_control_slave_address;             // mm_interconnect_0:sysid_qsys_control_slave_address -> sysid_qsys:address
	wire  [31:0] mm_interconnect_0_nios2_gen2_0_debug_mem_slave_readdata;        // nios2_gen2_0:debug_mem_slave_readdata -> mm_interconnect_0:nios2_gen2_0_debug_mem_slave_readdata
	wire         mm_interconnect_0_nios2_gen2_0_debug_mem_slave_waitrequest;     // nios2_gen2_0:debug_mem_slave_waitrequest -> mm_interconnect_0:nios2_gen2_0_debug_mem_slave_waitrequest
	wire         mm_interconnect_0_nios2_gen2_0_debug_mem_slave_debugaccess;     // mm_interconnect_0:nios2_gen2_0_debug_mem_slave_debugaccess -> nios2_gen2_0:debug_mem_slave_debugaccess
	wire   [8:0] mm_interconnect_0_nios2_gen2_0_debug_mem_slave_address;         // mm_interconnect_0:nios2_gen2_0_debug_mem_slave_address -> nios2_gen2_0:debug_mem_slave_address
	wire         mm_interconnect_0_nios2_gen2_0_debug_mem_slave_read;            // mm_interconnect_0:nios2_gen2_0_debug_mem_slave_read -> nios2_gen2_0:debug_mem_slave_read
	wire   [3:0] mm_interconnect_0_nios2_gen2_0_debug_mem_slave_byteenable;      // mm_interconnect_0:nios2_gen2_0_debug_mem_slave_byteenable -> nios2_gen2_0:debug_mem_slave_byteenable
	wire         mm_interconnect_0_nios2_gen2_0_debug_mem_slave_write;           // mm_interconnect_0:nios2_gen2_0_debug_mem_slave_write -> nios2_gen2_0:debug_mem_slave_write
	wire  [31:0] mm_interconnect_0_nios2_gen2_0_debug_mem_slave_writedata;       // mm_interconnect_0:nios2_gen2_0_debug_mem_slave_writedata -> nios2_gen2_0:debug_mem_slave_writedata
	wire         mm_interconnect_0_epcs_controller_epcs_control_port_chipselect; // mm_interconnect_0:epcs_controller_epcs_control_port_chipselect -> epcs_controller:chipselect
	wire  [31:0] mm_interconnect_0_epcs_controller_epcs_control_port_readdata;   // epcs_controller:readdata -> mm_interconnect_0:epcs_controller_epcs_control_port_readdata
	wire   [8:0] mm_interconnect_0_epcs_controller_epcs_control_port_address;    // mm_interconnect_0:epcs_controller_epcs_control_port_address -> epcs_controller:address
	wire         mm_interconnect_0_epcs_controller_epcs_control_port_read;       // mm_interconnect_0:epcs_controller_epcs_control_port_read -> epcs_controller:read_n
	wire         mm_interconnect_0_epcs_controller_epcs_control_port_write;      // mm_interconnect_0:epcs_controller_epcs_control_port_write -> epcs_controller:write_n
	wire  [31:0] mm_interconnect_0_epcs_controller_epcs_control_port_writedata;  // mm_interconnect_0:epcs_controller_epcs_control_port_writedata -> epcs_controller:writedata
	wire  [31:0] mm_interconnect_0_altpll_pll_slave_readdata;                    // altpll:readdata -> mm_interconnect_0:altpll_pll_slave_readdata
	wire   [1:0] mm_interconnect_0_altpll_pll_slave_address;                     // mm_interconnect_0:altpll_pll_slave_address -> altpll:address
	wire         mm_interconnect_0_altpll_pll_slave_read;                        // mm_interconnect_0:altpll_pll_slave_read -> altpll:read
	wire         mm_interconnect_0_altpll_pll_slave_write;                       // mm_interconnect_0:altpll_pll_slave_write -> altpll:write
	wire  [31:0] mm_interconnect_0_altpll_pll_slave_writedata;                   // mm_interconnect_0:altpll_pll_slave_writedata -> altpll:writedata
	wire         mm_interconnect_0_buzzer_out_s1_chipselect;                     // mm_interconnect_0:buzzer_out_s1_chipselect -> buzzer_out:chipselect
	wire  [31:0] mm_interconnect_0_buzzer_out_s1_readdata;                       // buzzer_out:readdata -> mm_interconnect_0:buzzer_out_s1_readdata
	wire   [1:0] mm_interconnect_0_buzzer_out_s1_address;                        // mm_interconnect_0:buzzer_out_s1_address -> buzzer_out:address
	wire         mm_interconnect_0_buzzer_out_s1_write;                          // mm_interconnect_0:buzzer_out_s1_write -> buzzer_out:write_n
	wire  [31:0] mm_interconnect_0_buzzer_out_s1_writedata;                      // mm_interconnect_0:buzzer_out_s1_writedata -> buzzer_out:writedata
	wire  [31:0] mm_interconnect_0_car_voltage_data_s1_readdata;                 // car_voltage_data:readdata -> mm_interconnect_0:car_voltage_data_s1_readdata
	wire   [1:0] mm_interconnect_0_car_voltage_data_s1_address;                  // mm_interconnect_0:car_voltage_data_s1_address -> car_voltage_data:address
	wire         mm_interconnect_0_car_led_s1_chipselect;                        // mm_interconnect_0:car_led_s1_chipselect -> car_led:chipselect
	wire  [31:0] mm_interconnect_0_car_led_s1_readdata;                          // car_led:readdata -> mm_interconnect_0:car_led_s1_readdata
	wire   [1:0] mm_interconnect_0_car_led_s1_address;                           // mm_interconnect_0:car_led_s1_address -> car_led:address
	wire         mm_interconnect_0_car_led_s1_write;                             // mm_interconnect_0:car_led_s1_write -> car_led:write_n
	wire  [31:0] mm_interconnect_0_car_led_s1_writedata;                         // mm_interconnect_0:car_led_s1_writedata -> car_led:writedata
	wire         mm_interconnect_0_sdram_s1_chipselect;                          // mm_interconnect_0:sdram_s1_chipselect -> sdram:az_cs
	wire  [15:0] mm_interconnect_0_sdram_s1_readdata;                            // sdram:za_data -> mm_interconnect_0:sdram_s1_readdata
	wire         mm_interconnect_0_sdram_s1_waitrequest;                         // sdram:za_waitrequest -> mm_interconnect_0:sdram_s1_waitrequest
	wire  [23:0] mm_interconnect_0_sdram_s1_address;                             // mm_interconnect_0:sdram_s1_address -> sdram:az_addr
	wire         mm_interconnect_0_sdram_s1_read;                                // mm_interconnect_0:sdram_s1_read -> sdram:az_rd_n
	wire   [1:0] mm_interconnect_0_sdram_s1_byteenable;                          // mm_interconnect_0:sdram_s1_byteenable -> sdram:az_be_n
	wire         mm_interconnect_0_sdram_s1_readdatavalid;                       // sdram:za_valid -> mm_interconnect_0:sdram_s1_readdatavalid
	wire         mm_interconnect_0_sdram_s1_write;                               // mm_interconnect_0:sdram_s1_write -> sdram:az_wr_n
	wire  [15:0] mm_interconnect_0_sdram_s1_writedata;                           // mm_interconnect_0:sdram_s1_writedata -> sdram:az_data
	wire         mm_interconnect_0_timer_0_s1_chipselect;                        // mm_interconnect_0:timer_0_s1_chipselect -> timer_0:chipselect
	wire  [15:0] mm_interconnect_0_timer_0_s1_readdata;                          // timer_0:readdata -> mm_interconnect_0:timer_0_s1_readdata
	wire   [2:0] mm_interconnect_0_timer_0_s1_address;                           // mm_interconnect_0:timer_0_s1_address -> timer_0:address
	wire         mm_interconnect_0_timer_0_s1_write;                             // mm_interconnect_0:timer_0_s1_write -> timer_0:write_n
	wire  [15:0] mm_interconnect_0_timer_0_s1_writedata;                         // mm_interconnect_0:timer_0_s1_writedata -> timer_0:writedata
	wire         mm_interconnect_0_bts_tmd_s1_chipselect;                        // mm_interconnect_0:bts_tmd_s1_chipselect -> bts_tmd:chipselect
	wire  [15:0] mm_interconnect_0_bts_tmd_s1_readdata;                          // bts_tmd:readdata -> mm_interconnect_0:bts_tmd_s1_readdata
	wire   [2:0] mm_interconnect_0_bts_tmd_s1_address;                           // mm_interconnect_0:bts_tmd_s1_address -> bts_tmd:address
	wire         mm_interconnect_0_bts_tmd_s1_read;                              // mm_interconnect_0:bts_tmd_s1_read -> bts_tmd:read_n
	wire         mm_interconnect_0_bts_tmd_s1_begintransfer;                     // mm_interconnect_0:bts_tmd_s1_begintransfer -> bts_tmd:begintransfer
	wire         mm_interconnect_0_bts_tmd_s1_write;                             // mm_interconnect_0:bts_tmd_s1_write -> bts_tmd:write_n
	wire  [15:0] mm_interconnect_0_bts_tmd_s1_writedata;                         // mm_interconnect_0:bts_tmd_s1_writedata -> bts_tmd:writedata
	wire  [31:0] mm_interconnect_0_bts_tmd_connect_state_s1_readdata;            // bts_tmd_connect_state:readdata -> mm_interconnect_0:bts_tmd_connect_state_s1_readdata
	wire   [1:0] mm_interconnect_0_bts_tmd_connect_state_s1_address;             // mm_interconnect_0:bts_tmd_connect_state_s1_address -> bts_tmd_connect_state:address
	wire         irq_mapper_receiver0_irq;                                       // jtag_uart:av_irq -> irq_mapper:receiver0_irq
	wire         irq_mapper_receiver1_irq;                                       // epcs_controller:irq -> irq_mapper:receiver1_irq
	wire         irq_mapper_receiver2_irq;                                       // timer_0:irq -> irq_mapper:receiver2_irq
	wire         irq_mapper_receiver3_irq;                                       // bts_tmd:irq -> irq_mapper:receiver3_irq
	wire  [31:0] nios2_gen2_0_irq_irq;                                           // irq_mapper:sender_irq -> nios2_gen2_0:irq
	wire         rst_controller_reset_out_reset;                                 // rst_controller:reset_out -> [altpll:reset, mm_interconnect_0:altpll_inclk_interface_reset_reset_bridge_in_reset_reset]
	wire         rst_controller_001_reset_out_reset;                             // rst_controller_001:reset_out -> [bts_tmd:reset_n, bts_tmd_connect_state:reset_n, buzzer_out:reset_n, car_led:reset_n, car_voltage_data:reset_n, dc_motor_left:reset_n, dc_motor_right:reset_n, jtag_uart:rst_n, mm_interconnect_0:jtag_uart_reset_reset_bridge_in_reset_reset, sysid_qsys:reset_n, timer_0:reset_n]
	wire         rst_controller_002_reset_out_reset;                             // rst_controller_002:reset_out -> [epcs_controller:reset_n, irq_mapper:reset, mm_interconnect_0:nios2_gen2_0_reset_reset_bridge_in_reset_reset, nios2_gen2_0:reset_n, rst_translator:in_reset, sdram:reset_n]
	wire         rst_controller_002_reset_out_reset_req;                         // rst_controller_002:reset_req -> [epcs_controller:reset_req, nios2_gen2_0:reset_req, rst_translator:reset_req_in]
	wire         nios2_gen2_0_debug_reset_request_reset;                         // nios2_gen2_0:debug_reset_request -> rst_controller_002:reset_in1

	Qsys_altpll altpll (
		.clk       (clk_clk),                                      //       inclk_interface.clk
		.reset     (rst_controller_reset_out_reset),               // inclk_interface_reset.reset
		.read      (mm_interconnect_0_altpll_pll_slave_read),      //             pll_slave.read
		.write     (mm_interconnect_0_altpll_pll_slave_write),     //                      .write
		.address   (mm_interconnect_0_altpll_pll_slave_address),   //                      .address
		.readdata  (mm_interconnect_0_altpll_pll_slave_readdata),  //                      .readdata
		.writedata (mm_interconnect_0_altpll_pll_slave_writedata), //                      .writedata
		.c0        (altpll_c0_clk),                                //                    c0.clk
		.c1        (altpll_sdram_clk),                             //                    c1.clk
		.areset    (altpll_areset_conduit_export),                 //        areset_conduit.export
		.locked    (altpll_locked_conduit_export),                 //        locked_conduit.export
		.phasedone (altpll_phasedone_conduit_export)               //     phasedone_conduit.export
	);

	Qsys_bts_tmd bts_tmd (
		.clk           (altpll_c0_clk),                              //                 clk.clk
		.reset_n       (~rst_controller_001_reset_out_reset),        //               reset.reset_n
		.address       (mm_interconnect_0_bts_tmd_s1_address),       //                  s1.address
		.begintransfer (mm_interconnect_0_bts_tmd_s1_begintransfer), //                    .begintransfer
		.chipselect    (mm_interconnect_0_bts_tmd_s1_chipselect),    //                    .chipselect
		.read_n        (~mm_interconnect_0_bts_tmd_s1_read),         //                    .read_n
		.write_n       (~mm_interconnect_0_bts_tmd_s1_write),        //                    .write_n
		.writedata     (mm_interconnect_0_bts_tmd_s1_writedata),     //                    .writedata
		.readdata      (mm_interconnect_0_bts_tmd_s1_readdata),      //                    .readdata
		.dataavailable (),                                           //                    .dataavailable
		.readyfordata  (),                                           //                    .readyfordata
		.endofpacket   (),                                           //                    .endofpacket
		.rxd           (bts_tmd_external_connection_rxd),            // external_connection.export
		.txd           (bts_tmd_external_connection_txd),            //                    .export
		.cts_n         (bts_tmd_external_connection_cts_n),          //                    .export
		.rts_n         (bts_tmd_external_connection_rts_n),          //                    .export
		.irq           (irq_mapper_receiver3_irq)                    //                 irq.irq
	);

	Qsys_bts_tmd_connect_state bts_tmd_connect_state (
		.clk      (altpll_c0_clk),                                       //                 clk.clk
		.reset_n  (~rst_controller_001_reset_out_reset),                 //               reset.reset_n
		.address  (mm_interconnect_0_bts_tmd_connect_state_s1_address),  //                  s1.address
		.readdata (mm_interconnect_0_bts_tmd_connect_state_s1_readdata), //                    .readdata
		.in_port  (bts_tmd_connect_state_external_connection_export)     // external_connection.export
	);

	Qsys_buzzer_out buzzer_out (
		.clk        (altpll_c0_clk),                              //                 clk.clk
		.reset_n    (~rst_controller_001_reset_out_reset),        //               reset.reset_n
		.address    (mm_interconnect_0_buzzer_out_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_buzzer_out_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_buzzer_out_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_buzzer_out_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_buzzer_out_s1_readdata),   //                    .readdata
		.out_port   (buzzer_out_external_connection_export)       // external_connection.export
	);

	Qsys_car_led car_led (
		.clk        (altpll_c0_clk),                           //                 clk.clk
		.reset_n    (~rst_controller_001_reset_out_reset),     //               reset.reset_n
		.address    (mm_interconnect_0_car_led_s1_address),    //                  s1.address
		.write_n    (~mm_interconnect_0_car_led_s1_write),     //                    .write_n
		.writedata  (mm_interconnect_0_car_led_s1_writedata),  //                    .writedata
		.chipselect (mm_interconnect_0_car_led_s1_chipselect), //                    .chipselect
		.readdata   (mm_interconnect_0_car_led_s1_readdata),   //                    .readdata
		.out_port   (car_led_external_connection_export)       // external_connection.export
	);

	Qsys_car_voltage_data car_voltage_data (
		.clk      (altpll_c0_clk),                                  //                 clk.clk
		.reset_n  (~rst_controller_001_reset_out_reset),            //               reset.reset_n
		.address  (mm_interconnect_0_car_voltage_data_s1_address),  //                  s1.address
		.readdata (mm_interconnect_0_car_voltage_data_s1_readdata), //                    .readdata
		.in_port  (car_voltage_data_external_connection_export)     // external_connection.export
	);

	TERASIC_DC_MOTOR_PWM dc_motor_left (
		.clk         (altpll_c0_clk),                                           //        clock.clk
		.reset_n     (~rst_controller_001_reset_out_reset),                     //        reset.reset_n
		.s_cs        (mm_interconnect_0_dc_motor_left_avalon_slave_chipselect), // avalon_slave.chipselect
		.s_address   (mm_interconnect_0_dc_motor_left_avalon_slave_address),    //             .address
		.s_write     (mm_interconnect_0_dc_motor_left_avalon_slave_write),      //             .write
		.s_writedata (mm_interconnect_0_dc_motor_left_avalon_slave_writedata),  //             .writedata
		.s_read      (mm_interconnect_0_dc_motor_left_avalon_slave_read),       //             .read
		.s_readdata  (mm_interconnect_0_dc_motor_left_avalon_slave_readdata),   //             .readdata
		.DC_MOTOR_P  (dc_motor_left_conduit_end_motor_p),                       //  conduit_end.motor_p
		.DC_MOTOR_N  (dc_motor_left_conduit_end_motor_n)                        //             .motor_n
	);

	TERASIC_DC_MOTOR_PWM dc_motor_right (
		.clk         (altpll_c0_clk),                                            //        clock.clk
		.reset_n     (~rst_controller_001_reset_out_reset),                      //        reset.reset_n
		.s_cs        (mm_interconnect_0_dc_motor_right_avalon_slave_chipselect), // avalon_slave.chipselect
		.s_address   (mm_interconnect_0_dc_motor_right_avalon_slave_address),    //             .address
		.s_write     (mm_interconnect_0_dc_motor_right_avalon_slave_write),      //             .write
		.s_writedata (mm_interconnect_0_dc_motor_right_avalon_slave_writedata),  //             .writedata
		.s_read      (mm_interconnect_0_dc_motor_right_avalon_slave_read),       //             .read
		.s_readdata  (mm_interconnect_0_dc_motor_right_avalon_slave_readdata),   //             .readdata
		.DC_MOTOR_P  (dc_motor_right_conduit_end_motor_p),                       //  conduit_end.motor_p
		.DC_MOTOR_N  (dc_motor_right_conduit_end_motor_n)                        //             .motor_n
	);

	Qsys_epcs_controller epcs_controller (
		.clk           (altpll_c0_clk),                                                  //               clk.clk
		.reset_n       (~rst_controller_002_reset_out_reset),                            //             reset.reset_n
		.reset_req     (rst_controller_002_reset_out_reset_req),                         //                  .reset_req
		.address       (mm_interconnect_0_epcs_controller_epcs_control_port_address),    // epcs_control_port.address
		.chipselect    (mm_interconnect_0_epcs_controller_epcs_control_port_chipselect), //                  .chipselect
		.dataavailable (),                                                               //                  .dataavailable
		.endofpacket   (),                                                               //                  .endofpacket
		.read_n        (~mm_interconnect_0_epcs_controller_epcs_control_port_read),      //                  .read_n
		.readdata      (mm_interconnect_0_epcs_controller_epcs_control_port_readdata),   //                  .readdata
		.readyfordata  (),                                                               //                  .readyfordata
		.write_n       (~mm_interconnect_0_epcs_controller_epcs_control_port_write),     //                  .write_n
		.writedata     (mm_interconnect_0_epcs_controller_epcs_control_port_writedata),  //                  .writedata
		.irq           (irq_mapper_receiver1_irq),                                       //               irq.irq
		.dclk          (epcs_controller_external_dclk),                                  //          external.export
		.sce           (epcs_controller_external_sce),                                   //                  .export
		.sdo           (epcs_controller_external_sdo),                                   //                  .export
		.data0         (epcs_controller_external_data0)                                  //                  .export
	);

	Qsys_jtag_uart jtag_uart (
		.clk            (altpll_c0_clk),                                             //               clk.clk
		.rst_n          (~rst_controller_001_reset_out_reset),                       //             reset.reset_n
		.av_chipselect  (mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect),  // avalon_jtag_slave.chipselect
		.av_address     (mm_interconnect_0_jtag_uart_avalon_jtag_slave_address),     //                  .address
		.av_read_n      (~mm_interconnect_0_jtag_uart_avalon_jtag_slave_read),       //                  .read_n
		.av_readdata    (mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata),    //                  .readdata
		.av_write_n     (~mm_interconnect_0_jtag_uart_avalon_jtag_slave_write),      //                  .write_n
		.av_writedata   (mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata),   //                  .writedata
		.av_waitrequest (mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest), //                  .waitrequest
		.av_irq         (irq_mapper_receiver0_irq)                                   //               irq.irq
	);

	Qsys_nios2_gen2_0 nios2_gen2_0 (
		.clk                                 (altpll_c0_clk),                                              //                       clk.clk
		.reset_n                             (~rst_controller_002_reset_out_reset),                        //                     reset.reset_n
		.reset_req                           (rst_controller_002_reset_out_reset_req),                     //                          .reset_req
		.d_address                           (nios2_gen2_0_data_master_address),                           //               data_master.address
		.d_byteenable                        (nios2_gen2_0_data_master_byteenable),                        //                          .byteenable
		.d_read                              (nios2_gen2_0_data_master_read),                              //                          .read
		.d_readdata                          (nios2_gen2_0_data_master_readdata),                          //                          .readdata
		.d_waitrequest                       (nios2_gen2_0_data_master_waitrequest),                       //                          .waitrequest
		.d_write                             (nios2_gen2_0_data_master_write),                             //                          .write
		.d_writedata                         (nios2_gen2_0_data_master_writedata),                         //                          .writedata
		.d_readdatavalid                     (nios2_gen2_0_data_master_readdatavalid),                     //                          .readdatavalid
		.debug_mem_slave_debugaccess_to_roms (nios2_gen2_0_data_master_debugaccess),                       //                          .debugaccess
		.i_address                           (nios2_gen2_0_instruction_master_address),                    //        instruction_master.address
		.i_read                              (nios2_gen2_0_instruction_master_read),                       //                          .read
		.i_readdata                          (nios2_gen2_0_instruction_master_readdata),                   //                          .readdata
		.i_waitrequest                       (nios2_gen2_0_instruction_master_waitrequest),                //                          .waitrequest
		.i_readdatavalid                     (nios2_gen2_0_instruction_master_readdatavalid),              //                          .readdatavalid
		.irq                                 (nios2_gen2_0_irq_irq),                                       //                       irq.irq
		.debug_reset_request                 (nios2_gen2_0_debug_reset_request_reset),                     //       debug_reset_request.reset
		.debug_mem_slave_address             (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_address),     //           debug_mem_slave.address
		.debug_mem_slave_byteenable          (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_byteenable),  //                          .byteenable
		.debug_mem_slave_debugaccess         (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_debugaccess), //                          .debugaccess
		.debug_mem_slave_read                (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_read),        //                          .read
		.debug_mem_slave_readdata            (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_readdata),    //                          .readdata
		.debug_mem_slave_waitrequest         (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_waitrequest), //                          .waitrequest
		.debug_mem_slave_write               (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_write),       //                          .write
		.debug_mem_slave_writedata           (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_writedata),   //                          .writedata
		.dummy_ci_port                       ()                                                            // custom_instruction_master.readra
	);

	Qsys_sdram sdram (
		.clk            (altpll_c0_clk),                            //   clk.clk
		.reset_n        (~rst_controller_002_reset_out_reset),      // reset.reset_n
		.az_addr        (mm_interconnect_0_sdram_s1_address),       //    s1.address
		.az_be_n        (~mm_interconnect_0_sdram_s1_byteenable),   //      .byteenable_n
		.az_cs          (mm_interconnect_0_sdram_s1_chipselect),    //      .chipselect
		.az_data        (mm_interconnect_0_sdram_s1_writedata),     //      .writedata
		.az_rd_n        (~mm_interconnect_0_sdram_s1_read),         //      .read_n
		.az_wr_n        (~mm_interconnect_0_sdram_s1_write),        //      .write_n
		.za_data        (mm_interconnect_0_sdram_s1_readdata),      //      .readdata
		.za_valid       (mm_interconnect_0_sdram_s1_readdatavalid), //      .readdatavalid
		.za_waitrequest (mm_interconnect_0_sdram_s1_waitrequest),   //      .waitrequest
		.zs_addr        (sdram_wire_addr),                          //  wire.export
		.zs_ba          (sdram_wire_ba),                            //      .export
		.zs_cas_n       (sdram_wire_cas_n),                         //      .export
		.zs_cke         (sdram_wire_cke),                           //      .export
		.zs_cs_n        (sdram_wire_cs_n),                          //      .export
		.zs_dq          (sdram_wire_dq),                            //      .export
		.zs_dqm         (sdram_wire_dqm),                           //      .export
		.zs_ras_n       (sdram_wire_ras_n),                         //      .export
		.zs_we_n        (sdram_wire_we_n)                           //      .export
	);

	Qsys_sysid_qsys sysid_qsys (
		.clock    (altpll_c0_clk),                                       //           clk.clk
		.reset_n  (~rst_controller_001_reset_out_reset),                 //         reset.reset_n
		.readdata (mm_interconnect_0_sysid_qsys_control_slave_readdata), // control_slave.readdata
		.address  (mm_interconnect_0_sysid_qsys_control_slave_address)   //              .address
	);

	Qsys_timer_0 timer_0 (
		.clk        (altpll_c0_clk),                           //   clk.clk
		.reset_n    (~rst_controller_001_reset_out_reset),     // reset.reset_n
		.address    (mm_interconnect_0_timer_0_s1_address),    //    s1.address
		.writedata  (mm_interconnect_0_timer_0_s1_writedata),  //      .writedata
		.readdata   (mm_interconnect_0_timer_0_s1_readdata),   //      .readdata
		.chipselect (mm_interconnect_0_timer_0_s1_chipselect), //      .chipselect
		.write_n    (~mm_interconnect_0_timer_0_s1_write),     //      .write_n
		.irq        (irq_mapper_receiver2_irq)                 //   irq.irq
	);

	Qsys_mm_interconnect_0 mm_interconnect_0 (
		.altpll_c0_clk                                            (altpll_c0_clk),                                                  //                                          altpll_c0.clk
		.clk_0_clk_clk                                            (clk_clk),                                                        //                                          clk_0_clk.clk
		.altpll_inclk_interface_reset_reset_bridge_in_reset_reset (rst_controller_reset_out_reset),                                 // altpll_inclk_interface_reset_reset_bridge_in_reset.reset
		.jtag_uart_reset_reset_bridge_in_reset_reset              (rst_controller_001_reset_out_reset),                             //              jtag_uart_reset_reset_bridge_in_reset.reset
		.nios2_gen2_0_reset_reset_bridge_in_reset_reset           (rst_controller_002_reset_out_reset),                             //           nios2_gen2_0_reset_reset_bridge_in_reset.reset
		.nios2_gen2_0_data_master_address                         (nios2_gen2_0_data_master_address),                               //                           nios2_gen2_0_data_master.address
		.nios2_gen2_0_data_master_waitrequest                     (nios2_gen2_0_data_master_waitrequest),                           //                                                   .waitrequest
		.nios2_gen2_0_data_master_byteenable                      (nios2_gen2_0_data_master_byteenable),                            //                                                   .byteenable
		.nios2_gen2_0_data_master_read                            (nios2_gen2_0_data_master_read),                                  //                                                   .read
		.nios2_gen2_0_data_master_readdata                        (nios2_gen2_0_data_master_readdata),                              //                                                   .readdata
		.nios2_gen2_0_data_master_readdatavalid                   (nios2_gen2_0_data_master_readdatavalid),                         //                                                   .readdatavalid
		.nios2_gen2_0_data_master_write                           (nios2_gen2_0_data_master_write),                                 //                                                   .write
		.nios2_gen2_0_data_master_writedata                       (nios2_gen2_0_data_master_writedata),                             //                                                   .writedata
		.nios2_gen2_0_data_master_debugaccess                     (nios2_gen2_0_data_master_debugaccess),                           //                                                   .debugaccess
		.nios2_gen2_0_instruction_master_address                  (nios2_gen2_0_instruction_master_address),                        //                    nios2_gen2_0_instruction_master.address
		.nios2_gen2_0_instruction_master_waitrequest              (nios2_gen2_0_instruction_master_waitrequest),                    //                                                   .waitrequest
		.nios2_gen2_0_instruction_master_read                     (nios2_gen2_0_instruction_master_read),                           //                                                   .read
		.nios2_gen2_0_instruction_master_readdata                 (nios2_gen2_0_instruction_master_readdata),                       //                                                   .readdata
		.nios2_gen2_0_instruction_master_readdatavalid            (nios2_gen2_0_instruction_master_readdatavalid),                  //                                                   .readdatavalid
		.altpll_pll_slave_address                                 (mm_interconnect_0_altpll_pll_slave_address),                     //                                   altpll_pll_slave.address
		.altpll_pll_slave_write                                   (mm_interconnect_0_altpll_pll_slave_write),                       //                                                   .write
		.altpll_pll_slave_read                                    (mm_interconnect_0_altpll_pll_slave_read),                        //                                                   .read
		.altpll_pll_slave_readdata                                (mm_interconnect_0_altpll_pll_slave_readdata),                    //                                                   .readdata
		.altpll_pll_slave_writedata                               (mm_interconnect_0_altpll_pll_slave_writedata),                   //                                                   .writedata
		.bts_tmd_s1_address                                       (mm_interconnect_0_bts_tmd_s1_address),                           //                                         bts_tmd_s1.address
		.bts_tmd_s1_write                                         (mm_interconnect_0_bts_tmd_s1_write),                             //                                                   .write
		.bts_tmd_s1_read                                          (mm_interconnect_0_bts_tmd_s1_read),                              //                                                   .read
		.bts_tmd_s1_readdata                                      (mm_interconnect_0_bts_tmd_s1_readdata),                          //                                                   .readdata
		.bts_tmd_s1_writedata                                     (mm_interconnect_0_bts_tmd_s1_writedata),                         //                                                   .writedata
		.bts_tmd_s1_begintransfer                                 (mm_interconnect_0_bts_tmd_s1_begintransfer),                     //                                                   .begintransfer
		.bts_tmd_s1_chipselect                                    (mm_interconnect_0_bts_tmd_s1_chipselect),                        //                                                   .chipselect
		.bts_tmd_connect_state_s1_address                         (mm_interconnect_0_bts_tmd_connect_state_s1_address),             //                           bts_tmd_connect_state_s1.address
		.bts_tmd_connect_state_s1_readdata                        (mm_interconnect_0_bts_tmd_connect_state_s1_readdata),            //                                                   .readdata
		.buzzer_out_s1_address                                    (mm_interconnect_0_buzzer_out_s1_address),                        //                                      buzzer_out_s1.address
		.buzzer_out_s1_write                                      (mm_interconnect_0_buzzer_out_s1_write),                          //                                                   .write
		.buzzer_out_s1_readdata                                   (mm_interconnect_0_buzzer_out_s1_readdata),                       //                                                   .readdata
		.buzzer_out_s1_writedata                                  (mm_interconnect_0_buzzer_out_s1_writedata),                      //                                                   .writedata
		.buzzer_out_s1_chipselect                                 (mm_interconnect_0_buzzer_out_s1_chipselect),                     //                                                   .chipselect
		.car_led_s1_address                                       (mm_interconnect_0_car_led_s1_address),                           //                                         car_led_s1.address
		.car_led_s1_write                                         (mm_interconnect_0_car_led_s1_write),                             //                                                   .write
		.car_led_s1_readdata                                      (mm_interconnect_0_car_led_s1_readdata),                          //                                                   .readdata
		.car_led_s1_writedata                                     (mm_interconnect_0_car_led_s1_writedata),                         //                                                   .writedata
		.car_led_s1_chipselect                                    (mm_interconnect_0_car_led_s1_chipselect),                        //                                                   .chipselect
		.car_voltage_data_s1_address                              (mm_interconnect_0_car_voltage_data_s1_address),                  //                                car_voltage_data_s1.address
		.car_voltage_data_s1_readdata                             (mm_interconnect_0_car_voltage_data_s1_readdata),                 //                                                   .readdata
		.dc_motor_left_avalon_slave_address                       (mm_interconnect_0_dc_motor_left_avalon_slave_address),           //                         dc_motor_left_avalon_slave.address
		.dc_motor_left_avalon_slave_write                         (mm_interconnect_0_dc_motor_left_avalon_slave_write),             //                                                   .write
		.dc_motor_left_avalon_slave_read                          (mm_interconnect_0_dc_motor_left_avalon_slave_read),              //                                                   .read
		.dc_motor_left_avalon_slave_readdata                      (mm_interconnect_0_dc_motor_left_avalon_slave_readdata),          //                                                   .readdata
		.dc_motor_left_avalon_slave_writedata                     (mm_interconnect_0_dc_motor_left_avalon_slave_writedata),         //                                                   .writedata
		.dc_motor_left_avalon_slave_chipselect                    (mm_interconnect_0_dc_motor_left_avalon_slave_chipselect),        //                                                   .chipselect
		.dc_motor_right_avalon_slave_address                      (mm_interconnect_0_dc_motor_right_avalon_slave_address),          //                        dc_motor_right_avalon_slave.address
		.dc_motor_right_avalon_slave_write                        (mm_interconnect_0_dc_motor_right_avalon_slave_write),            //                                                   .write
		.dc_motor_right_avalon_slave_read                         (mm_interconnect_0_dc_motor_right_avalon_slave_read),             //                                                   .read
		.dc_motor_right_avalon_slave_readdata                     (mm_interconnect_0_dc_motor_right_avalon_slave_readdata),         //                                                   .readdata
		.dc_motor_right_avalon_slave_writedata                    (mm_interconnect_0_dc_motor_right_avalon_slave_writedata),        //                                                   .writedata
		.dc_motor_right_avalon_slave_chipselect                   (mm_interconnect_0_dc_motor_right_avalon_slave_chipselect),       //                                                   .chipselect
		.epcs_controller_epcs_control_port_address                (mm_interconnect_0_epcs_controller_epcs_control_port_address),    //                  epcs_controller_epcs_control_port.address
		.epcs_controller_epcs_control_port_write                  (mm_interconnect_0_epcs_controller_epcs_control_port_write),      //                                                   .write
		.epcs_controller_epcs_control_port_read                   (mm_interconnect_0_epcs_controller_epcs_control_port_read),       //                                                   .read
		.epcs_controller_epcs_control_port_readdata               (mm_interconnect_0_epcs_controller_epcs_control_port_readdata),   //                                                   .readdata
		.epcs_controller_epcs_control_port_writedata              (mm_interconnect_0_epcs_controller_epcs_control_port_writedata),  //                                                   .writedata
		.epcs_controller_epcs_control_port_chipselect             (mm_interconnect_0_epcs_controller_epcs_control_port_chipselect), //                                                   .chipselect
		.jtag_uart_avalon_jtag_slave_address                      (mm_interconnect_0_jtag_uart_avalon_jtag_slave_address),          //                        jtag_uart_avalon_jtag_slave.address
		.jtag_uart_avalon_jtag_slave_write                        (mm_interconnect_0_jtag_uart_avalon_jtag_slave_write),            //                                                   .write
		.jtag_uart_avalon_jtag_slave_read                         (mm_interconnect_0_jtag_uart_avalon_jtag_slave_read),             //                                                   .read
		.jtag_uart_avalon_jtag_slave_readdata                     (mm_interconnect_0_jtag_uart_avalon_jtag_slave_readdata),         //                                                   .readdata
		.jtag_uart_avalon_jtag_slave_writedata                    (mm_interconnect_0_jtag_uart_avalon_jtag_slave_writedata),        //                                                   .writedata
		.jtag_uart_avalon_jtag_slave_waitrequest                  (mm_interconnect_0_jtag_uart_avalon_jtag_slave_waitrequest),      //                                                   .waitrequest
		.jtag_uart_avalon_jtag_slave_chipselect                   (mm_interconnect_0_jtag_uart_avalon_jtag_slave_chipselect),       //                                                   .chipselect
		.nios2_gen2_0_debug_mem_slave_address                     (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_address),         //                       nios2_gen2_0_debug_mem_slave.address
		.nios2_gen2_0_debug_mem_slave_write                       (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_write),           //                                                   .write
		.nios2_gen2_0_debug_mem_slave_read                        (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_read),            //                                                   .read
		.nios2_gen2_0_debug_mem_slave_readdata                    (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_readdata),        //                                                   .readdata
		.nios2_gen2_0_debug_mem_slave_writedata                   (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_writedata),       //                                                   .writedata
		.nios2_gen2_0_debug_mem_slave_byteenable                  (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_byteenable),      //                                                   .byteenable
		.nios2_gen2_0_debug_mem_slave_waitrequest                 (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_waitrequest),     //                                                   .waitrequest
		.nios2_gen2_0_debug_mem_slave_debugaccess                 (mm_interconnect_0_nios2_gen2_0_debug_mem_slave_debugaccess),     //                                                   .debugaccess
		.sdram_s1_address                                         (mm_interconnect_0_sdram_s1_address),                             //                                           sdram_s1.address
		.sdram_s1_write                                           (mm_interconnect_0_sdram_s1_write),                               //                                                   .write
		.sdram_s1_read                                            (mm_interconnect_0_sdram_s1_read),                                //                                                   .read
		.sdram_s1_readdata                                        (mm_interconnect_0_sdram_s1_readdata),                            //                                                   .readdata
		.sdram_s1_writedata                                       (mm_interconnect_0_sdram_s1_writedata),                           //                                                   .writedata
		.sdram_s1_byteenable                                      (mm_interconnect_0_sdram_s1_byteenable),                          //                                                   .byteenable
		.sdram_s1_readdatavalid                                   (mm_interconnect_0_sdram_s1_readdatavalid),                       //                                                   .readdatavalid
		.sdram_s1_waitrequest                                     (mm_interconnect_0_sdram_s1_waitrequest),                         //                                                   .waitrequest
		.sdram_s1_chipselect                                      (mm_interconnect_0_sdram_s1_chipselect),                          //                                                   .chipselect
		.sysid_qsys_control_slave_address                         (mm_interconnect_0_sysid_qsys_control_slave_address),             //                           sysid_qsys_control_slave.address
		.sysid_qsys_control_slave_readdata                        (mm_interconnect_0_sysid_qsys_control_slave_readdata),            //                                                   .readdata
		.timer_0_s1_address                                       (mm_interconnect_0_timer_0_s1_address),                           //                                         timer_0_s1.address
		.timer_0_s1_write                                         (mm_interconnect_0_timer_0_s1_write),                             //                                                   .write
		.timer_0_s1_readdata                                      (mm_interconnect_0_timer_0_s1_readdata),                          //                                                   .readdata
		.timer_0_s1_writedata                                     (mm_interconnect_0_timer_0_s1_writedata),                         //                                                   .writedata
		.timer_0_s1_chipselect                                    (mm_interconnect_0_timer_0_s1_chipselect)                         //                                                   .chipselect
	);

	Qsys_irq_mapper irq_mapper (
		.clk           (altpll_c0_clk),                      //       clk.clk
		.reset         (rst_controller_002_reset_out_reset), // clk_reset.reset
		.receiver0_irq (irq_mapper_receiver0_irq),           // receiver0.irq
		.receiver1_irq (irq_mapper_receiver1_irq),           // receiver1.irq
		.receiver2_irq (irq_mapper_receiver2_irq),           // receiver2.irq
		.receiver3_irq (irq_mapper_receiver3_irq),           // receiver3.irq
		.sender_irq    (nios2_gen2_0_irq_irq)                //    sender.irq
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller (
		.reset_in0      (~reset_reset_n),                 // reset_in0.reset
		.clk            (clk_clk),                        //       clk.clk
		.reset_out      (rst_controller_reset_out_reset), // reset_out.reset
		.reset_req      (),                               // (terminated)
		.reset_req_in0  (1'b0),                           // (terminated)
		.reset_in1      (1'b0),                           // (terminated)
		.reset_req_in1  (1'b0),                           // (terminated)
		.reset_in2      (1'b0),                           // (terminated)
		.reset_req_in2  (1'b0),                           // (terminated)
		.reset_in3      (1'b0),                           // (terminated)
		.reset_req_in3  (1'b0),                           // (terminated)
		.reset_in4      (1'b0),                           // (terminated)
		.reset_req_in4  (1'b0),                           // (terminated)
		.reset_in5      (1'b0),                           // (terminated)
		.reset_req_in5  (1'b0),                           // (terminated)
		.reset_in6      (1'b0),                           // (terminated)
		.reset_req_in6  (1'b0),                           // (terminated)
		.reset_in7      (1'b0),                           // (terminated)
		.reset_req_in7  (1'b0),                           // (terminated)
		.reset_in8      (1'b0),                           // (terminated)
		.reset_req_in8  (1'b0),                           // (terminated)
		.reset_in9      (1'b0),                           // (terminated)
		.reset_req_in9  (1'b0),                           // (terminated)
		.reset_in10     (1'b0),                           // (terminated)
		.reset_req_in10 (1'b0),                           // (terminated)
		.reset_in11     (1'b0),                           // (terminated)
		.reset_req_in11 (1'b0),                           // (terminated)
		.reset_in12     (1'b0),                           // (terminated)
		.reset_req_in12 (1'b0),                           // (terminated)
		.reset_in13     (1'b0),                           // (terminated)
		.reset_req_in13 (1'b0),                           // (terminated)
		.reset_in14     (1'b0),                           // (terminated)
		.reset_req_in14 (1'b0),                           // (terminated)
		.reset_in15     (1'b0),                           // (terminated)
		.reset_req_in15 (1'b0)                            // (terminated)
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (1),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (0),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_001 (
		.reset_in0      (~reset_reset_n),                     // reset_in0.reset
		.clk            (altpll_c0_clk),                      //       clk.clk
		.reset_out      (rst_controller_001_reset_out_reset), // reset_out.reset
		.reset_req      (),                                   // (terminated)
		.reset_req_in0  (1'b0),                               // (terminated)
		.reset_in1      (1'b0),                               // (terminated)
		.reset_req_in1  (1'b0),                               // (terminated)
		.reset_in2      (1'b0),                               // (terminated)
		.reset_req_in2  (1'b0),                               // (terminated)
		.reset_in3      (1'b0),                               // (terminated)
		.reset_req_in3  (1'b0),                               // (terminated)
		.reset_in4      (1'b0),                               // (terminated)
		.reset_req_in4  (1'b0),                               // (terminated)
		.reset_in5      (1'b0),                               // (terminated)
		.reset_req_in5  (1'b0),                               // (terminated)
		.reset_in6      (1'b0),                               // (terminated)
		.reset_req_in6  (1'b0),                               // (terminated)
		.reset_in7      (1'b0),                               // (terminated)
		.reset_req_in7  (1'b0),                               // (terminated)
		.reset_in8      (1'b0),                               // (terminated)
		.reset_req_in8  (1'b0),                               // (terminated)
		.reset_in9      (1'b0),                               // (terminated)
		.reset_req_in9  (1'b0),                               // (terminated)
		.reset_in10     (1'b0),                               // (terminated)
		.reset_req_in10 (1'b0),                               // (terminated)
		.reset_in11     (1'b0),                               // (terminated)
		.reset_req_in11 (1'b0),                               // (terminated)
		.reset_in12     (1'b0),                               // (terminated)
		.reset_req_in12 (1'b0),                               // (terminated)
		.reset_in13     (1'b0),                               // (terminated)
		.reset_req_in13 (1'b0),                               // (terminated)
		.reset_in14     (1'b0),                               // (terminated)
		.reset_req_in14 (1'b0),                               // (terminated)
		.reset_in15     (1'b0),                               // (terminated)
		.reset_req_in15 (1'b0)                                // (terminated)
	);

	altera_reset_controller #(
		.NUM_RESET_INPUTS          (2),
		.OUTPUT_RESET_SYNC_EDGES   ("deassert"),
		.SYNC_DEPTH                (2),
		.RESET_REQUEST_PRESENT     (1),
		.RESET_REQ_WAIT_TIME       (1),
		.MIN_RST_ASSERTION_TIME    (3),
		.RESET_REQ_EARLY_DSRT_TIME (1),
		.USE_RESET_REQUEST_IN0     (0),
		.USE_RESET_REQUEST_IN1     (0),
		.USE_RESET_REQUEST_IN2     (0),
		.USE_RESET_REQUEST_IN3     (0),
		.USE_RESET_REQUEST_IN4     (0),
		.USE_RESET_REQUEST_IN5     (0),
		.USE_RESET_REQUEST_IN6     (0),
		.USE_RESET_REQUEST_IN7     (0),
		.USE_RESET_REQUEST_IN8     (0),
		.USE_RESET_REQUEST_IN9     (0),
		.USE_RESET_REQUEST_IN10    (0),
		.USE_RESET_REQUEST_IN11    (0),
		.USE_RESET_REQUEST_IN12    (0),
		.USE_RESET_REQUEST_IN13    (0),
		.USE_RESET_REQUEST_IN14    (0),
		.USE_RESET_REQUEST_IN15    (0),
		.ADAPT_RESET_REQUEST       (0)
	) rst_controller_002 (
		.reset_in0      (~reset_reset_n),                         // reset_in0.reset
		.reset_in1      (nios2_gen2_0_debug_reset_request_reset), // reset_in1.reset
		.clk            (altpll_c0_clk),                          //       clk.clk
		.reset_out      (rst_controller_002_reset_out_reset),     // reset_out.reset
		.reset_req      (rst_controller_002_reset_out_reset_req), //          .reset_req
		.reset_req_in0  (1'b0),                                   // (terminated)
		.reset_req_in1  (1'b0),                                   // (terminated)
		.reset_in2      (1'b0),                                   // (terminated)
		.reset_req_in2  (1'b0),                                   // (terminated)
		.reset_in3      (1'b0),                                   // (terminated)
		.reset_req_in3  (1'b0),                                   // (terminated)
		.reset_in4      (1'b0),                                   // (terminated)
		.reset_req_in4  (1'b0),                                   // (terminated)
		.reset_in5      (1'b0),                                   // (terminated)
		.reset_req_in5  (1'b0),                                   // (terminated)
		.reset_in6      (1'b0),                                   // (terminated)
		.reset_req_in6  (1'b0),                                   // (terminated)
		.reset_in7      (1'b0),                                   // (terminated)
		.reset_req_in7  (1'b0),                                   // (terminated)
		.reset_in8      (1'b0),                                   // (terminated)
		.reset_req_in8  (1'b0),                                   // (terminated)
		.reset_in9      (1'b0),                                   // (terminated)
		.reset_req_in9  (1'b0),                                   // (terminated)
		.reset_in10     (1'b0),                                   // (terminated)
		.reset_req_in10 (1'b0),                                   // (terminated)
		.reset_in11     (1'b0),                                   // (terminated)
		.reset_req_in11 (1'b0),                                   // (terminated)
		.reset_in12     (1'b0),                                   // (terminated)
		.reset_req_in12 (1'b0),                                   // (terminated)
		.reset_in13     (1'b0),                                   // (terminated)
		.reset_req_in13 (1'b0),                                   // (terminated)
		.reset_in14     (1'b0),                                   // (terminated)
		.reset_req_in14 (1'b0),                                   // (terminated)
		.reset_in15     (1'b0),                                   // (terminated)
		.reset_req_in15 (1'b0)                                    // (terminated)
	);

endmodule
