
module nios_system (
	adc_ltc2308_conduit_end_convst,
	adc_ltc2308_conduit_end_sck,
	adc_ltc2308_conduit_end_sdi,
	adc_ltc2308_conduit_end_sdo,
	buzzer_external_connection_export,
	clk_clk,
	dc_motor_left_conduit_end_motor_p,
	dc_motor_left_conduit_end_motor_n,
	dc_motor_right_conduit_end_motor_p,
	dc_motor_right_conduit_end_motor_n,
	ir_led_on_external_connection_export,
	ir_rx_conduit_end_export,
	key_external_connection_export,
	led_external_connection_export,
	light_left_external_connection_export,
	light_right_external_connection_export,
	reset_reset_n,
	scd_3v3_poweron_n_external_connection_export,
	switch_external_connection_export,
	tmd_status_external_connection_export,
	uart_external_connection_rxd,
	uart_external_connection_txd,
	uart_external_connection_cts_n,
	uart_external_connection_rts_n);	

	output		adc_ltc2308_conduit_end_convst;
	output		adc_ltc2308_conduit_end_sck;
	output		adc_ltc2308_conduit_end_sdi;
	input		adc_ltc2308_conduit_end_sdo;
	output		buzzer_external_connection_export;
	input		clk_clk;
	output		dc_motor_left_conduit_end_motor_p;
	output		dc_motor_left_conduit_end_motor_n;
	output		dc_motor_right_conduit_end_motor_p;
	output		dc_motor_right_conduit_end_motor_n;
	output		ir_led_on_external_connection_export;
	input		ir_rx_conduit_end_export;
	input	[1:0]	key_external_connection_export;
	output	[7:0]	led_external_connection_export;
	output		light_left_external_connection_export;
	output		light_right_external_connection_export;
	input		reset_reset_n;
	output		scd_3v3_poweron_n_external_connection_export;
	input	[3:0]	switch_external_connection_export;
	input		tmd_status_external_connection_export;
	input		uart_external_connection_rxd;
	output		uart_external_connection_txd;
	input		uart_external_connection_cts_n;
	output		uart_external_connection_rts_n;
endmodule
